/* A Bison parser, made by GNU Bison 3.5.  */


/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Undocumented macros, especially those whose name start with YY_,
   are private implementation details.  Do not rely on them.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 1 "parser.y"


/* Copyright 2009-2020
 * Kaz Kylheku <kaz@kylheku.com>
 * Vancouver, Canada
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <stddef.h>
#include <stdio.h>
#include <assert.h>
#include <limits.h>
#include <dirent.h>
#include <stdlib.h>
#include <stdarg.h>
#include <setjmp.h>
#include <wchar.h>
#include <signal.h>
#include "config.h"
#include "alloca.h"
#include "lib.h"
#include "signal.h"
#include "unwind.h"
#include "regex.h"
#include "match.h"
#include "hash.h"
#include "struct.h"
#include "eval.h"
#include "tree.h"
#include "y.tab.h"
#include "gc.h"
#include "debug.h"
#include "txr.h"
#include "itypes.h"
#include "buf.h"
#include "parser.h"

static val sym_helper(parser_t *parser, wchar_t *lexeme, val meta_allowed);
static val repeat_rep_helper(val sym, val args, val main, val parts);
static void process_catch_exprs(val exprs);
static val define_transform(parser_t *parser, val define_form);
static val optimize_text(val text_form);
static val unquotes_occur(val quoted_form, int level);
static val rlrec(parser_t *, val form, val line);
static val rlcp_parser(parser_t *parser, val to, val from);
static wchar_t char_from_name(const wchar_t *name);
static val make_expr(parser_t *, val sym, val rest, val lineno);
static val check_parse_time_action(val spec_rev);
static void misplaced_consing_dot_check(scanner_t *scanner, val term_atom_cons);
static val uref_helper(parser_t *, val expr);
static val uoref_helper(parser_t *, val expr);
static val qref_helper(parser_t *, val lexpr, val rexpr);
static val fname_helper(parser_t *, val name);

#if YYBISON
union YYSTYPE;
int yylex(union YYSTYPE *, yyscan_t scanner);
int yyparse(scanner_t *, parser_t *);
#endif

#define rl(form, line) rlrec(parser, form, line)
#define rlc(to, from) rlcp_parser(parser, to, from)
#define mkexp(sym, rest, lineno) make_expr(parser, sym, rest, lineno)
#define symhlpr(lexeme, meta_allowed) sym_helper(parser, lexeme, meta_allowed)
#define yyerr(msg) yyerror(scnr, parser, msg)
#define yybadtok(tok, context) yybadtoken(parser, tok, context)
#define ifnign(expr) (parser->ignore ? nil : (expr))

INLINE val expand_forms_ver(val forms, int ver)
{
  if (!opt_compat || opt_compat >= ver)
    return expand_forms(forms, nil);
  return forms;
}

INLINE val expand_form_ver(val form, int ver)
{
  if (!opt_compat || opt_compat >= ver)
    return expand(form, nil);
  return form;
}


#line 175 "y.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_YY_Y_TAB_H_INCLUDED
# define YY_YY_Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    SPACE = 258,
    TEXT = 259,
    SYMTOK = 260,
    ALL = 261,
    SOME = 262,
    NONE = 263,
    MAYBE = 264,
    CASES = 265,
    BLOCK = 266,
    CHOOSE = 267,
    GATHER = 268,
    AND = 269,
    OR = 270,
    END = 271,
    COLLECT = 272,
    UNTIL = 273,
    COLL = 274,
    OUTPUT = 275,
    REPEAT = 276,
    REP = 277,
    SINGLE = 278,
    FIRST = 279,
    LAST = 280,
    EMPTY = 281,
    MOD = 282,
    MODLAST = 283,
    DEFINE = 284,
    TRY = 285,
    CATCH = 286,
    FINALLY = 287,
    IF = 288,
    ERRTOK = 289,
    HASH_BACKSLASH = 290,
    HASH_SLASH = 291,
    DOTDOT = 292,
    HASH_H = 293,
    HASH_S = 294,
    HASH_R = 295,
    HASH_SEMI = 296,
    HASH_B_QUOTE = 297,
    HASH_N = 298,
    HASH_T = 299,
    WORDS = 300,
    WSPLICE = 301,
    QWORDS = 302,
    QWSPLICE = 303,
    SECRET_ESCAPE_R = 304,
    SECRET_ESCAPE_E = 305,
    SECRET_ESCAPE_I = 306,
    OLD_DOTDOT = 307,
    NUMBER = 308,
    METANUM = 309,
    HASH_N_EQUALS = 310,
    HASH_N_HASH = 311,
    REGCHAR = 312,
    REGTOKEN = 313,
    LITCHAR = 314,
    SPLICE = 315,
    CONSDOT = 316,
    LAMBDOT = 317,
    UREFDOT = 318,
    OREFDOT = 319,
    UOREFDOT = 320,
    LOW = 321,
    ELIF = 322,
    ELSE = 323
  };
#endif
/* Tokens.  */
#define SPACE 258
#define TEXT 259
#define SYMTOK 260
#define ALL 261
#define SOME 262
#define NONE 263
#define MAYBE 264
#define CASES 265
#define BLOCK 266
#define CHOOSE 267
#define GATHER 268
#define AND 269
#define OR 270
#define END 271
#define COLLECT 272
#define UNTIL 273
#define COLL 274
#define OUTPUT 275
#define REPEAT 276
#define REP 277
#define SINGLE 278
#define FIRST 279
#define LAST 280
#define EMPTY 281
#define MOD 282
#define MODLAST 283
#define DEFINE 284
#define TRY 285
#define CATCH 286
#define FINALLY 287
#define IF 288
#define ERRTOK 289
#define HASH_BACKSLASH 290
#define HASH_SLASH 291
#define DOTDOT 292
#define HASH_H 293
#define HASH_S 294
#define HASH_R 295
#define HASH_SEMI 296
#define HASH_B_QUOTE 297
#define HASH_N 298
#define HASH_T 299
#define WORDS 300
#define WSPLICE 301
#define QWORDS 302
#define QWSPLICE 303
#define SECRET_ESCAPE_R 304
#define SECRET_ESCAPE_E 305
#define SECRET_ESCAPE_I 306
#define OLD_DOTDOT 307
#define NUMBER 308
#define METANUM 309
#define HASH_N_EQUALS 310
#define HASH_N_HASH 311
#define REGCHAR 312
#define REGTOKEN 313
#define LITCHAR 314
#define SPLICE 315
#define CONSDOT 316
#define LAMBDOT 317
#define UREFDOT 318
#define OREFDOT 319
#define UOREFDOT 320
#define LOW 321
#define ELIF 322
#define ELSE 323

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 111 "parser.y"

  wchar_t *lexeme;
  union obj *val;
  wchar_t chr;
  cnum lineno;

#line 370 "y.tab.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif



int yyparse (scanner_t *scnr, parser_t *parser);

#endif /* !YY_YY_Y_TAB_H_INCLUDED  */



#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))

/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  198
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   4332

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  94
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  115
/* YYNRULES -- Number of rules.  */
#define YYNRULES  412
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  736

#define YYUNDEFTOK  2
#define YYMAXUTOK   323


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      89,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,    93,     2,    91,    90,     2,    87,    82,    78,
      66,    75,    84,    86,    77,    76,    88,    81,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    85,    68,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    67,     2,    74,    79,     2,    92,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    70,    80,    71,    83,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    69,    72,    73
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   177,   177,   178,   180,   179,   183,   182,   185,   192,
     199,   208,   208,   211,   211,   214,   214,   217,   218,   219,
     222,   222,   225,   225,   228,   228,   231,   232,   233,   238,
     239,   240,   243,   244,   247,   248,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   263,   264,   265,   266,
     269,   271,   275,   278,   284,   286,   290,   292,   296,   298,
     302,   313,   318,   321,   326,   335,   347,   352,   356,   357,
     358,   361,   367,   379,   384,   385,   388,   389,   392,   395,
     396,   397,   400,   423,   427,   440,   443,   448,   451,   454,
     455,   458,   460,   465,   466,   474,   476,   479,   480,   483,
     485,   487,   495,   498,   506,   509,   518,   521,   523,   525,
     527,   528,   530,   531,   532,   533,   536,   542,   545,   546,
     547,   550,   555,   559,   561,   563,   568,   576,   581,   586,
     592,   597,   598,   601,   604,   610,   614,   616,   619,   631,
     636,   638,   641,   644,   647,   652,   653,   656,   657,   660,
     666,   671,   675,   679,   688,   692,   699,   706,   710,   711,
     713,   716,   718,   721,   722,   723,   724,   727,   729,   731,
     732,   734,   737,   740,   744,   747,   750,   758,   761,   767,
     773,   780,   781,   782,   783,   784,   785,   788,   792,   794,
     798,   801,   802,   804,   806,   809,   814,   823,   827,   830,
     835,   840,   844,   850,   854,   861,   865,   869,   873,   878,
     882,   895,   899,   900,   906,   907,   908,   909,   913,   918,
     922,   926,   927,   928,   932,   933,   934,   937,   940,   941,
     944,   951,   954,   954,   957,   957,   960,   967,   972,   974,
     982,   984,   994,   995,   997,   998,   999,  1000,  1001,  1002,
    1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,
    1014,  1014,  1018,  1018,  1022,  1022,  1026,  1026,  1029,  1032,
    1033,  1035,  1036,  1038,  1039,  1040,  1041,  1042,  1043,  1044,
    1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,  1053,  1055,
    1055,  1059,  1059,  1063,  1063,  1067,  1070,  1076,  1080,  1086,
    1087,  1090,  1091,  1092,  1092,  1095,  1098,  1099,  1102,  1103,
    1104,  1107,  1110,  1115,  1119,  1125,  1128,  1129,  1130,  1131,
    1134,  1135,  1136,  1139,  1140,  1141,  1142,  1143,  1150,  1151,
    1153,  1154,  1155,  1156,  1157,  1158,  1159,  1163,  1164,  1167,
    1168,  1169,  1172,  1174,  1175,  1176,  1177,  1178,  1179,  1180,
    1181,  1182,  1183,  1184,  1185,  1188,  1202,  1203,  1207,  1208,
    1210,  1214,  1227,  1229,  1234,  1235,  1238,  1242,  1244,  1248,
    1249,  1250,  1251,  1253,  1260,  1261,  1265,  1266,  1269,  1270,
    1271,  1273,  1277,  1278,  1279,  1281,  1287,  1289,  1292,  1297,
    1299,  1303,  1304,  1311,  1312,  1313,  1314,  1315,  1316,  1317,
    1318,  1319,  1320,  1321,  1322,  1324,  1326,  1328,  1330,  1332,
    1334,  1336,  1338
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "SPACE", "TEXT", "SYMTOK", "ALL", "SOME",
  "NONE", "MAYBE", "CASES", "BLOCK", "CHOOSE", "GATHER", "AND", "OR",
  "END", "COLLECT", "UNTIL", "COLL", "OUTPUT", "REPEAT", "REP", "SINGLE",
  "FIRST", "LAST", "EMPTY", "MOD", "MODLAST", "DEFINE", "TRY", "CATCH",
  "FINALLY", "IF", "ERRTOK", "HASH_BACKSLASH", "HASH_SLASH", "DOTDOT",
  "HASH_H", "HASH_S", "HASH_R", "HASH_SEMI", "HASH_B_QUOTE", "HASH_N",
  "HASH_T", "WORDS", "WSPLICE", "QWORDS", "QWSPLICE", "SECRET_ESCAPE_R",
  "SECRET_ESCAPE_E", "SECRET_ESCAPE_I", "OLD_DOTDOT", "NUMBER", "METANUM",
  "HASH_N_EQUALS", "HASH_N_HASH", "REGCHAR", "REGTOKEN", "LITCHAR",
  "SPLICE", "CONSDOT", "LAMBDOT", "UREFDOT", "OREFDOT", "UOREFDOT", "'('",
  "'['", "'@'", "LOW", "'{'", "'}'", "ELIF", "ELSE", "']'", "')'", "'-'",
  "','", "'\\''", "'^'", "'|'", "'/'", "'&'", "'~'", "'*'", "'?'", "'+'",
  "'%'", "'.'", "'\\n'", "'#'", "'\"'", "'`'", "' '", "$accept", "spec",
  "$@1", "$@2", "hash_semi_or_n_expr", "$@3", "$@4", "$@5",
  "hash_semi_or_i_expr", "$@6", "$@7", "$@8", "byacc_fool", "clauses_rev",
  "clauses_opt", "clause", "all_clause", "some_clause", "none_clause",
  "maybe_clause", "cases_clause", "block_clause", "choose_clause",
  "gather_clause", "gather_parts", "additional_gather_parts",
  "collect_clause", "collect_repeat", "until_last", "clause_parts",
  "additional_parts", "if_clause", "elif_clauses_opt", "else_clause_opt",
  "line", "elems_opt", "elems", "text", "texts", "elem", "clause_parts_h",
  "additional_parts_h", "define_clause", "try_clause", "catch_clauses_opt",
  "output_clause", "out_clauses", "out_clause", "repeat_clause",
  "repeat_parts_opt", "out_clauses_opt", "o_line", "o_elems_opt",
  "o_elems", "o_elem", "rep_elem", "rep_parts_opt", "var", "var_op",
  "modifiers", "o_var", "q_var", "vector", "hash", "struct", "range",
  "tnode", "tree", "list", "meta", "dwim", "compound", "exprs",
  "exprs_opt", "n_exprs", "r_exprs", "$@9", "$@10", "i_expr", "$@11",
  "$@12", "$@13", "$@14", "i_dot_expr", "n_expr", "$@15", "$@16", "$@17",
  "$@18", "n_exprs_opt", "n_dot_expr", "regex", "lisp_regex", "regexpr",
  "regbranch", "regterm", "regclass", "regclassterm", "regrange",
  "regchar", "regtoken", "newl", "strlit", "chrlit", "quasilit",
  "quasi_items", "quasi_item", "litchars", "restlitchar", "wordslit",
  "wordsqlit", "buflit", "buflit_items", "buflit_item", "not_a_clause", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,    40,    91,    64,   321,
     123,   125,   322,   323,    93,    41,    45,    44,    39,    94,
     124,    47,    38,   126,    42,    63,    43,    37,    46,    10,
      35,    34,    96,    32
};
# endif

#define YYPACT_NINF (-614)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-320)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    1773,   -40,  -614,  -614,  3234,  3321,  3498,  3321,  3321,  3321,
    1204,  3498,  3498,  -614,  1272,  1340,  -614,  1408,  -614,  1476,
      24,  3498,  1068,  3557,  3685,   852,    34,   879,  -614,    81,
    2169,  -614,  -614,  -614,  -614,  -614,  -614,  -614,  -614,  -614,
    -614,  -614,  3498,  -614,  -614,   -21,  -614,    41,  -614,  4217,
    -614,  -614,  -614,  -614,    25,  -614,  -614,  -614,  -614,    -3,
    4217,  3498,  4217,  4217,  4217,  1204,  3498,  3498,  -614,   159,
    -614,  2371,  -614,    35,  1072,    11,    13,    33,  -614,    46,
      49,    57,    28,    28,    52,    52,  -614,  -614,  -614,  -614,
    -614,  3979,  3979,  1024,  1612,  -614,  3621,  -614,    77,    37,
      97,  -614,  -614,  -614,  -614,  -614,  -614,  -614,  -614,  -614,
    -614,  -614,   -23,  -614,  3380,   280,  -614,  -614,  -614,  -614,
    -614,  -614,  2402,  -614,  2489,  -614,  2520,  -614,    22,    63,
      72,  -614,    78,  -614,  2284,   104,  -614,   109,  -614,    24,
     115,  2607,  -614,   119,  -614,  -614,  1752,   196,  -614,  -614,
    1068,  -614,   -45,  -614,  1837,  -614,   -42,  3979,  3979,  -614,
     280,  -614,   -37,    28,    52,  -614,  -614,  -614,  -614,  -614,
    4096,  -614,  4038,  -614,  4096,  -614,  -614,  -614,  -614,  -614,
    -614,  -614,  -614,  -614,  -614,  -614,  -614,  -614,  -614,  -614,
    3979,  3979,  -614,  3498,   121,   234,  -614,   259,  -614,  -614,
     123,  -614,  -614,  -614,  -614,  -614,    80,  -614,   127,   131,
     133,   134,  4217,  4217,  -614,  -614,  -614,   386,  -614,  -614,
    -614,  -614,  -614,   393,  -614,  -614,  -614,  -614,  -614,  -614,
    3979,  -614,    23,  -614,   -18,  -614,  -614,  -614,  -614,  -614,
    -614,   112,  -614,    28,    28,  -614,  -614,  -614,  -614,  3743,
    -614,    52,  -614,   -50,   132,  -614,  -614,  -614,  3621,  3621,
     200,   200,  -614,  -614,  3498,   149,  -614,   280,  3621,  3979,
    3979,   280,  -614,  3621,  -614,  -614,  -614,  -614,   136,  -614,
    -614,   137,  3321,  -614,    28,    52,  3979,   280,  3802,  3861,
    3979,  3979,  -614,  -614,  -614,  -614,  -614,  -614,  1029,  3321,
      24,  4217,  -614,  -614,  1860,  -614,  -614,  -614,  -614,  -614,
    3498,  3498,  3498,  -614,  -614,  3498,  3498,  3498,  1544,  3498,
    -614,  3498,  -614,  3498,  3979,  -614,  -614,   142,  4259,  -614,
    -614,  -614,  1947,  4259,  2284,  4217,  2998,  1029,  -614,   128,
      24,  -614,    75,  -614,  -614,  -614,  -614,  -614,  -614,  -614,
    -614,  -614,  -614,  -614,  -614,  -614,  -614,   161,   703,  -614,
     167,  -614,  -614,  1068,  1068,  1068,  -614,  -614,  -614,  1068,
    -614,  -614,  -614,  3979,   280,   280,  3920,  -614,  -614,  4096,
    -614,  -614,  4038,  4038,  -614,  4038,  4096,  -614,  -614,  4038,
    -614,  3920,   170,   270,   169,  -614,  -614,  -614,  -614,   176,
    -614,  -614,  -614,    24,    96,  4217,  4217,  4217,  4217,  -614,
    -614,    24,    24,    24,  -614,  -614,   280,  -614,  -614,  -614,
    -614,  -614,   192,  -614,  -614,  1680,   280,  -614,  -614,    52,
    -614,  -614,  -614,   181,  -614,  -614,   200,   200,  -614,  -614,
    -614,  -614,  2641,  3979,  -614,  -614,   280,  3979,   280,  3979,
     205,   200,   200,   245,  3085,  -614,  2728,  2034,   247,  -614,
     193,   194,   198,   199,   210,   211,  -614,   214,   224,   228,
     231,  3316,  2065,  -614,  -614,    24,  1136,   293,  4186,  -614,
    -614,   221,  -614,  -614,   230,  2138,   279,  -614,   305,   307,
    3116,  3439,    24,   315,  2759,  -614,  -614,  -614,   916,   253,
    -614,  -614,  -614,  3979,  3979,   280,  -614,  -614,   280,  4096,
    4096,  -614,  -614,  -614,  -614,  -614,  -614,  -614,  -614,  -614,
    -614,  -614,  2846,   266,  -614,   271,  2169,  2169,  -614,  -614,
    -614,  3316,  -614,  -614,  -614,  -614,   280,   200,   200,  -614,
    -614,   334,  -614,  -614,  -614,    50,   338,  -614,  -614,  -614,
    3498,  -614,  -614,  -614,  -614,  -614,  -614,  4259,  -614,  -614,
    -614,   286,  -614,   335,  -614,   287,   363,    24,  -614,  -614,
    2211,  -614,   357,  -614,  3498,    24,  -614,  -614,   360,    24,
     309,  3203,    24,  -614,   308,  -614,   280,   280,  -614,  -614,
    -614,   354,  -614,  -614,  -614,  -614,   323,    24,    24,    24,
    -614,    24,  3498,   328,   559,  -614,    24,    24,  -614,  -614,
    -614,   382,    24,   341,  -614,    24,  2877,    24,  -614,  -614,
    -614,  3498,   340,    24,  3498,  -614,  -614,  2169,  2169,  -614,
     347,  4217,  4259,  4259,  3498,  4259,  3498,  3498,   407,  -614,
    4186,    24,  -614,  4217,  -614,  -614,   128,  2964,   362,    24,
     424,  -614,   369,  -614,  -614,    24,   430,   559,   559,   374,
     559,   377,   380,  -614,  -614,   613,  -614,   432,  -614,  -614,
     128,    24,  2169,    24,    24,  2169,  -614,  -614,  -614,  4259,
    -614,  4259,  4259,    24,    24,  3498,    24,  3498,  3498,   440,
    -614,  -614,  2169,  -614,  -614,  2169,   442,   559,   559,   559,
    4186,  4186,   391,  4186,   392,   401,    24,   308,   462,    24,
    -614,  -614,  -614,   613,   613,    24,   613,    24,    24,  -614,
    -614,    24,  -614,  -614,  -614,  4186,  -614,  4186,  4186,  -614,
     613,   613,   613,  -614,  -614,  -614
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       0,     0,    94,    93,     0,     0,   229,     0,     0,     0,
       0,   229,   229,    74,     0,     0,    75,     0,    96,     0,
       0,   307,   319,     8,     9,     0,     0,     0,   190,     0,
      34,     2,    32,    36,    37,    38,    39,    40,    41,    42,
      44,    43,   229,    47,    49,     0,    89,    97,    99,    91,
      45,    46,    48,   100,     0,   101,    95,    10,   188,     0,
      90,   229,    90,    90,    90,     0,   229,     0,   356,     0,
     110,     0,   271,     0,     0,     0,     0,     0,   232,     0,
       0,     0,     0,     0,     0,     0,   273,   272,   303,   305,
     293,     0,     0,     0,     0,   291,     0,   289,     0,     0,
       0,   275,   276,   277,   278,   279,   280,   224,   226,   225,
     274,   228,     0,   227,   230,   231,   281,   283,   282,   284,
     287,   112,     0,   113,     0,   114,     0,   109,     0,     0,
       0,   107,     0,   140,     0,     0,   108,     0,   123,     0,
       0,     0,   306,     0,   333,   355,     0,     0,   331,   332,
     319,   330,     3,   315,   320,   334,    11,     0,     0,     4,
      17,   242,    20,     0,     0,   244,   243,   266,   268,   264,
       0,   262,     0,   260,     0,     6,   246,   247,   248,   249,
     250,   251,   245,    26,   252,   254,   253,   255,   258,   217,
       0,     0,   214,     0,     0,     0,   312,     0,     1,    33,
       0,    88,    98,    92,   189,   184,     0,   357,     0,     0,
       0,     0,    90,    90,   118,   117,    51,     0,    50,   363,
     361,   362,   314,     0,   203,   202,   205,   204,   207,   206,
       0,   388,     0,   386,     0,   390,   209,   208,   211,   210,
     381,   374,   378,     0,     0,   285,   238,   370,   372,     0,
     382,     0,   371,     0,   367,   369,   286,   240,     0,     0,
     301,   302,   223,   222,     0,     0,   219,   218,     0,     0,
       0,   310,   288,     0,   201,   200,   360,   358,     0,   366,
     364,     0,     0,   234,     0,     0,     0,   236,     0,     0,
       0,     0,    55,    54,    57,    56,    59,    58,     0,     0,
       0,    90,   168,   167,     0,   393,   394,   395,   396,   397,
     229,   229,   229,   398,   399,   229,   229,   229,     0,   229,
     400,   229,   401,   229,     0,   403,   402,     0,   163,   171,
     169,   170,     0,   165,     0,     0,     0,     0,   127,   131,
       0,   336,     0,   329,   354,   347,   328,   348,   349,   353,
     351,   350,   345,   343,   346,   352,   344,     0,   337,   339,
     340,   341,   318,   319,   319,   319,   323,   325,   324,   319,
     321,    15,    13,     0,    19,    18,    31,    24,    22,     0,
     256,   257,     0,     0,    28,     0,     0,   270,   259,     0,
      27,    31,     0,     0,     0,   212,   194,   191,   182,     0,
     193,   192,   311,     0,     0,    90,     0,    90,     0,   119,
     120,     0,     0,     0,    78,   313,   233,   392,   391,   387,
     389,   376,   375,   379,   380,     0,   373,   383,   384,     0,
     368,   304,   294,     0,   221,   292,   309,   308,   290,   359,
     365,   111,     0,     0,   239,   241,   237,     0,   295,     0,
     297,   300,   299,     0,     0,   115,     0,     0,     0,   197,
       0,     0,     0,     0,     0,     0,   173,     0,     0,     0,
       0,   307,     0,   164,   142,     0,     0,     0,   145,   147,
     148,     0,   161,   166,     0,     0,     0,   125,     0,     0,
       0,     0,     0,     0,     0,   335,   327,   338,     0,   316,
     317,   322,   326,     0,     0,    12,    30,     5,    29,     0,
       0,    21,   267,   265,   263,   269,   261,     7,   216,   215,
     213,   183,     0,     0,   185,     0,    35,    35,    79,   377,
     199,   307,   385,   220,    53,    52,   235,   296,   298,   106,
      61,     0,    63,    62,    66,    70,     0,   102,    76,    77,
     229,   404,   405,   408,   406,   407,   412,   162,   409,   410,
     411,     0,   141,     0,   136,     0,     0,     0,   146,   160,
       0,   144,     0,   104,   229,     0,   116,   124,     0,     0,
       0,     0,     0,    83,    85,   342,    16,    14,    25,    23,
      73,     0,   187,   186,    80,    81,     0,     0,     0,     0,
      67,     0,   229,     0,   180,   196,     0,     0,   150,   137,
     143,     0,     0,     0,   122,     0,     0,     0,   134,   130,
     126,   307,    87,     0,   229,   198,    60,    35,    35,    64,
       0,    90,   162,   162,   229,   162,   229,   229,     0,   135,
     159,     0,   138,     0,   121,   132,   131,     0,     0,     0,
       0,    71,     0,    68,    69,     0,     0,   180,   180,     0,
     180,     0,     0,   172,   158,   157,   139,     0,   128,   133,
     131,     0,    35,     0,     0,    35,   103,   174,   175,   162,
     177,   162,   162,     0,     0,   229,     0,   229,   229,     0,
     105,   129,    35,    86,    82,    35,     0,   180,   180,   180,
     159,   159,     0,   159,     0,     0,     0,    85,     0,     0,
     176,   178,   179,   157,   157,     0,   157,     0,     0,   149,
      84,     0,    65,   151,   152,   159,   154,   159,   159,    72,
     157,   157,   157,   153,   155,   156
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -614,  -614,  -614,  -614,  -614,  -614,  -614,  -614,  -614,  -614,
    -614,  -614,    93,  -614,   107,   459,  -614,  -614,  -614,  -614,
    -614,  -614,  -614,  -614,  -519,  -614,  -614,  -614,  -458,   -22,
    -614,  -614,  -214,  -614,  -614,    12,   -39,  -614,   444,  -614,
     642,  -614,  -614,  -614,  -613,  -614,  -324,  -614,  -614,  -216,
    -318,  -614,  -542,  -123,  -614,  -614,  -311,  -614,  -614,  -614,
    -614,  -614,    29,    42,    47,    56,    68,   144,    54,  -614,
    -614,    -8,   -12,   171,    48,  -614,  -614,  -614,    86,  -614,
    -614,  -614,  -614,    10,   720,  -614,  -614,  -614,  -614,  -313,
      70,  -189,   373,    -4,   345,  -614,   145,  -614,  -614,     8,
    -138,    -7,   439,   447,   456,   -82,  -614,   -51,  -614,     6,
     -81,   485,  -614,   261,  -614
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    29,   376,   391,   159,   373,   504,   503,   175,   379,
     510,   509,   507,    30,   217,    32,    33,    34,    35,    36,
      37,    38,    39,    40,   546,   600,    41,    42,   550,   218,
     414,    43,   622,   650,    44,    45,    46,    47,    48,    49,
      70,   215,    50,    51,   493,    52,   664,   478,   479,   689,
     665,   480,   481,   482,   328,   329,   638,    53,    54,   399,
     330,   252,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   230,   443,   387,   389,
     385,   383,   382,   388,   115,   273,   268,   259,   258,   143,
     272,    56,   116,   152,   153,   154,   357,   358,   359,   360,
     155,    71,   117,   118,   119,   253,   254,   255,   422,   245,
     256,   120,   234,   235,   333
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     122,   124,   126,   135,   257,   467,   401,   140,   477,   361,
     203,   327,   224,   141,   226,   604,   182,    69,   281,    69,
      69,    69,   371,   197,   417,    59,   204,   377,   574,   240,
     205,   244,   244,   668,   228,   363,   219,   364,   276,   195,
     220,   232,   428,   429,     2,     3,   372,   231,   278,    57,
     236,   378,   282,   176,    55,   211,   247,   691,   238,    55,
     419,    55,    55,    55,   598,   599,   177,    18,   201,   142,
     223,   178,    69,   194,    69,    69,    69,    25,   274,    25,
     179,   198,   418,   381,    55,   404,   207,   241,   602,   246,
     657,   658,   180,   660,   221,   206,   241,   298,   279,    25,
     293,   247,   295,    55,   297,   232,   248,    31,   653,   654,
     183,   241,   244,    68,    55,    25,    55,    55,    55,   242,
     249,   243,    27,    25,   233,    55,   331,   332,   277,   225,
     227,   229,   336,   624,   237,   239,   247,   697,   299,   698,
     699,   265,   342,    25,   250,   251,   362,   300,   563,   523,
     495,   248,   275,   301,   568,   363,   241,   364,   561,   491,
     492,   572,   182,   565,   182,   249,   182,   524,   181,   380,
     427,   421,   430,   212,   213,   214,    55,    27,    55,   334,
      55,   128,   129,   130,   335,   132,   248,   400,   137,   280,
     337,   241,   244,   244,   340,    55,   395,   343,   403,   176,
     249,   176,   405,   176,   445,   473,   406,   288,   407,   408,
     483,   484,   177,   200,   177,   525,   177,   178,   596,   178,
     361,   178,   289,   434,    69,    69,   179,   439,   179,   440,
     179,   472,   208,   244,   290,   496,   209,   210,   180,   396,
     180,   394,   180,   498,   520,   518,   611,   521,   339,   423,
     424,   529,   289,   344,   145,   533,   384,   289,   291,   453,
     390,   539,   345,   547,   290,   548,    55,    55,   551,   552,
     346,   347,   549,   553,   554,   442,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   555,   556,   397,   291,   557,
     444,   454,   456,   457,    69,   573,   486,   548,   489,   558,
      25,    93,    94,   559,   549,   398,   560,   288,   648,   567,
     569,    69,   433,   458,   181,    27,   181,   288,   181,   570,
     331,   575,   289,   576,   331,   331,   331,   485,   431,   432,
     490,   582,   289,   494,   290,   364,    55,   592,   435,   363,
     402,   364,   593,   438,   290,   519,   677,   678,   532,   680,
     597,   606,    55,    55,   601,    55,   548,   605,   291,   499,
     500,   501,   607,   549,   608,   502,   142,   453,   291,   489,
     623,   182,   548,   612,   182,   182,   615,   182,   182,   549,
     621,   182,   713,   714,   617,   716,   710,   711,   712,    55,
      55,    55,   512,   513,   625,   514,   522,   184,   641,   516,
     411,   412,   413,   631,   526,   527,   528,   730,   176,   731,
     732,   176,   176,   649,   176,   176,   643,    69,   176,    69,
     535,   177,   655,   663,   177,   177,   178,   177,   177,   178,
     178,   177,   178,   178,   543,   179,   178,   671,   179,   179,
     673,   179,   179,   488,   674,   179,   676,   180,   690,   679,
     180,   180,   681,   180,   180,   682,   706,   180,   709,    55,
      55,    55,    55,   185,   331,   511,   715,   717,   564,   566,
     331,   186,   515,   363,   415,   364,   718,   331,   721,   580,
     187,   460,   461,   462,   517,   581,   463,   464,   465,   199,
     468,   202,   469,   720,   470,   420,    55,   723,   724,   370,
     726,   182,   182,   497,   594,   595,   585,     0,    55,   188,
      55,    55,     0,     0,   733,   734,   735,     0,     0,   142,
       0,     0,     0,   181,   142,     0,   181,   181,     0,   181,
     181,     0,     0,   181,     0,     0,     0,     0,   176,   176,
       0,     0,     0,   184,    55,   184,     0,   184,    55,   331,
       0,   177,   177,     0,     0,     0,   178,   178,     0,     0,
     609,   541,   331,     0,   545,   179,   179,     0,   614,     0,
       0,     0,   616,     0,     0,   620,    55,   180,   180,   142,
      55,    55,   632,   633,   634,   635,   636,   637,     0,     0,
     626,   627,   628,     0,   629,   588,   589,   578,     0,   639,
     640,   584,     0,     0,   667,   642,     0,     0,   644,   185,
     647,   185,     0,   185,     0,     0,   651,   186,     0,   186,
       0,   186,     0,     0,   331,   331,   187,   331,   187,   591,
     187,     0,   331,     0,   666,    55,   683,   684,   685,   686,
     687,   688,   672,   656,     0,     0,     0,     0,   675,   121,
     123,   125,     0,   181,   181,   188,     0,   188,     0,   188,
       0,     0,     0,     0,   692,     0,   694,   695,     0,   142,
      55,   331,     0,   331,   331,     0,   700,   701,     0,   703,
       0,    55,    55,     0,     0,    55,     0,     0,   619,     0,
       0,     0,   331,   331,     0,   331,     0,    55,     0,   719,
       0,    55,   722,     0,   121,   123,   125,     0,   725,     0,
     727,   728,     0,     0,   729,     0,     0,   331,     0,   331,
     331,   603,     0,   646,     0,     0,    55,     0,     0,    55,
       0,     0,     0,     0,   545,   545,     0,     0,     0,     0,
       0,     0,     0,   160,     0,   613,    55,     0,     0,    55,
       0,     0,   184,     0,   670,   184,   184,     0,   184,   184,
     344,   145,   184,     0,     0,     0,     0,     0,     0,   345,
       0,     0,     0,   630,     0,     0,     0,     0,   347,   693,
       0,     0,   696,   348,   349,   350,   351,   352,   353,   354,
     355,   356,     0,     0,     0,   652,     0,     0,     0,   707,
       0,     0,   708,     0,     0,   659,     0,   661,   662,     0,
       0,   260,   261,     0,   267,     0,   271,     0,   185,     0,
       0,   185,   185,     0,   185,   185,   186,     0,   185,   186,
     186,     0,   186,   186,   287,   187,   186,     0,   187,   187,
       0,   187,   187,     0,     0,   187,     0,     0,     0,     0,
       0,     0,     0,   189,   409,   410,   702,    72,   704,   705,
       0,     0,     0,     0,   188,     0,     0,   188,   188,     0,
     188,   188,     0,     0,   188,     0,     0,   374,   375,     0,
     196,     0,   184,   184,     0,     0,     0,    73,    74,     0,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,     0,     0,     0,     0,    86,    87,    88,    89,     0,
     392,   393,    90,   190,   191,    91,     0,    92,    25,    93,
      94,     0,     0,     0,   441,     0,     0,   192,     0,    95,
      96,    97,     0,     0,     0,     0,   144,   145,     0,     0,
     193,   455,    98,    99,   100,   146,   147,     0,   185,   185,
     416,     0,     0,   148,     0,   149,   186,   186,     0,  -319,
    -319,  -319,   150,     0,     0,   187,   187,   151,     0,   426,
       0,     0,     0,   344,     0,     0,     0,     0,   271,   271,
       0,     0,   345,     0,     0,     0,     0,     0,   271,   436,
     437,   347,     0,   271,   188,   188,   348,   349,   350,   351,
     352,   353,   354,   355,   356,     0,   446,     0,   448,   450,
     451,   452,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   262,     0,     0,     0,    72,
      59,     0,     2,     3,     4,    60,    61,    62,    63,    64,
      65,    66,     0,     0,   471,     0,     0,   441,    14,   455,
       0,    17,     0,     0,     0,    18,     0,     0,    67,    73,
      74,     0,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,   222,     0,     0,     0,    86,    87,    88,
      89,     0,     0,     0,    90,     0,     0,    91,     0,    92,
      25,    93,    94,   505,     0,    25,   508,     0,   263,    26,
       0,    95,    96,    97,     0,     0,     0,     0,     0,     0,
      27,   508,   264,    28,    98,    99,   100,     0,    68,     0,
       0,     0,     0,     0,     0,   144,   145,     0,     0,   144,
     145,     0,     0,     0,   146,   147,     0,    59,   146,   147,
       0,    72,   148,     0,   149,   531,   148,     0,   149,     0,
       0,   150,  -319,  -319,  -319,   150,   151,     0,     0,     0,
     151,     0,     0,   536,     0,     0,     0,   537,     0,   538,
       0,    73,    74,     0,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,     0,     0,     0,     0,    86,
      87,    88,    89,     0,     0,     0,    90,     0,     0,    91,
       0,    92,    25,    93,    94,   127,     0,     0,     0,    72,
       0,  -307,     0,    95,    96,    97,     0,     0,     0,     0,
       0,     0,     0,   586,   587,    68,    98,    99,   100,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    73,
      74,     0,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,     0,     0,     0,     0,    86,    87,    88,
      89,     0,     0,     0,    90,     0,     0,    91,     0,    92,
      25,    93,    94,   131,     0,     0,     0,    72,     0,  -229,
       0,    95,    96,    97,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    98,    99,   100,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    73,    74,     0,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,     0,     0,     0,     0,    86,    87,    88,    89,     0,
       0,     0,    90,     0,     0,    91,     0,    92,    25,    93,
      94,   133,     0,     0,     0,    72,     0,  -229,     0,    95,
      96,    97,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    98,    99,   100,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    73,    74,     0,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,     0,
       0,     0,     0,    86,    87,    88,    89,     0,     0,     0,
      90,     0,     0,    91,     0,    92,    25,    93,    94,   136,
       0,     0,     0,    72,     0,   134,     0,    95,    96,    97,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      98,    99,   100,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    73,    74,     0,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,     0,     0,     0,
       0,    86,    87,    88,    89,     0,     0,     0,    90,     0,
       0,    91,     0,    92,    25,    93,    94,   138,     0,     0,
       0,    72,     0,  -229,     0,    95,    96,    97,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    98,    99,
     100,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    73,    74,     0,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,     0,     0,     0,     0,    86,
      87,    88,    89,     0,     0,     0,    90,     0,     0,    91,
       0,    92,    25,    93,    94,   466,     0,     0,     0,    72,
       0,   139,     0,    95,    96,    97,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    98,    99,   100,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    73,
      74,     0,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,     0,     0,     0,     0,    86,    87,    88,
      89,     0,     0,     0,    90,     0,     0,    91,     0,    92,
      25,    93,    94,   266,     0,     0,     0,    72,     0,  -307,
       0,    95,    96,    97,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    98,    99,   100,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    73,    74,     0,
      75,    76,    77,     0,    79,    80,    81,    82,     0,    84,
       0,     0,     0,     0,     0,    86,    87,    88,    89,     0,
       0,     0,    90,     0,     0,    91,     0,    92,    25,    93,
      94,   530,     0,     0,     0,    72,     0,     0,     0,    95,
      96,    97,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    98,    99,   100,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    73,    74,     0,    75,    76,
      77,     0,    79,    80,    81,    82,     0,    84,     0,     0,
       0,     0,     0,    86,    87,    88,    89,     0,     0,     0,
      90,     0,     0,    91,     0,    92,    25,    93,    94,     0,
       0,     0,     0,   341,     0,     0,     0,    95,    96,    97,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      98,    99,   100,   -35,     1,     0,     2,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,     0,     0,     0,
      13,     0,    14,    15,    16,    17,     0,     0,     0,    18,
       0,     0,    19,    20,     0,     0,    21,     0,     0,   144,
     145,     0,     0,     0,     0,     0,     0,     0,   146,   147,
       0,     0,    22,    23,    24,     0,   148,  -319,   149,     0,
       0,     0,  -319,     0,  -319,   150,     0,     0,     0,    25,
     151,     0,     0,    26,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    27,     0,     0,    28,     0,     0,
       0,   459,   -90,  -195,  -195,  -195,  -195,  -195,  -195,  -195,
    -195,  -195,  -195,  -195,  -195,  -195,  -195,  -195,     0,  -195,
    -195,     0,  -195,  -195,  -195,  -195,  -195,  -195,  -195,  -195,
    -195,  -195,  -195,  -195,   144,   145,     0,     0,     0,     0,
       0,     0,     0,   146,   147,     0,     0,     0,     0,     0,
       0,   148,     0,   149,     0,     0,     0,     0,     0,     0,
     365,   366,   367,   368,   369,   151,  -195,  -195,  -195,     0,
    -195,     0,  -195,  -195,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   474,  -195,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   475,   315,     0,   316,   317,   476,   318,
       0,     0,     0,     0,     0,     0,   319,   320,   321,   322,
     323,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    25,    93,    94,     0,   324,     0,   325,
     326,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   544,  -162,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,   -35,   -35,
     -35,    13,   -35,    14,    15,    16,    17,     0,     0,   -35,
      18,     0,     0,    19,    20,     0,   562,    21,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,     0,   315,     0,   316,   317,   476,   318,     0,     0,
       0,     0,     0,     0,   319,   320,   321,   322,   323,     0,
      25,     0,     0,     0,    26,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    27,     0,     0,    28,     0,
       0,     0,     0,   -90,     0,     0,     0,     0,     0,     0,
       0,    25,    93,    94,     0,   324,     0,   325,   326,   571,
       0,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,  -162,   315,     0,   316,   317,   476,
     318,     0,     0,     0,     0,     0,     0,   319,   320,   321,
     322,   323,     2,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,     0,     0,     0,    13,     0,    14,    15,
      16,    17,     0,     0,     0,    18,     0,     0,    19,    20,
       0,     0,    21,     0,    25,    93,    94,     0,   324,     0,
     325,   326,   610,     0,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,  -162,   315,     0,
     316,   317,   476,   318,     0,    25,     0,     0,     0,    26,
     319,   320,   321,   322,   323,     0,     0,     0,     0,     0,
      27,     0,     0,    28,     0,     0,     0,     0,   -90,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    25,    93,    94,
       0,   324,     0,   325,   326,    59,     0,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
    -162,   315,     0,   316,   317,     0,   318,     0,     0,     0,
       0,     0,     0,   319,   320,   321,   322,   323,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      25,    93,    94,     0,   324,     0,   325,   326,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   216,    68,     2,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,   -35,   -35,   -35,    13,     0,
      14,    15,    16,    17,     0,     0,     0,    18,     0,     0,
      19,    20,     0,   292,    21,     2,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,   -35,   -35,   -35,    13,
       0,    14,    15,    16,    17,     0,     0,     0,    18,     0,
       0,    19,    20,     0,     0,    21,     0,    25,     0,     0,
       0,    26,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    27,     0,     0,    28,     0,     0,     0,     0,
     -90,     0,     0,     0,     0,     0,     0,     0,    25,     0,
       0,     0,    26,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    27,     0,     0,    28,     0,     0,     0,
     294,   -90,     2,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,   -35,   -35,   -35,    13,     0,    14,    15,
      16,    17,     0,     0,     0,    18,     0,     0,    19,    20,
       0,   296,    21,     2,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,   -35,   -35,   -35,    13,     0,    14,
      15,    16,    17,     0,     0,     0,    18,     0,     0,    19,
      20,     0,     0,    21,     0,    25,     0,     0,     0,    26,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      27,     0,     0,    28,     0,     0,     0,     0,   -90,     0,
       0,     0,     0,     0,     0,     0,    25,     0,     0,     0,
      26,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    27,     0,     0,    28,     0,     0,     0,   338,   -90,
       2,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,     0,     0,   -35,    13,     0,    14,    15,    16,    17,
       0,     0,     0,    18,     0,     0,    19,    20,   -35,   -35,
      21,     0,   534,     0,     2,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,   -35,   -35,   -35,    13,     0,
      14,    15,    16,    17,     0,     0,     0,    18,     0,     0,
      19,    20,     0,    25,    21,     0,     0,    26,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    27,     0,
       0,    28,     0,     0,     0,     0,   -90,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    25,     0,     0,
       0,    26,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    27,     0,     0,    28,     0,     0,     0,   542,
     -90,     2,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,   -35,   -35,   -35,    13,     0,    14,    15,    16,
      17,     0,     0,     0,    18,     0,     0,    19,    20,     0,
     583,    21,     2,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,     0,     0,   -35,    13,     0,    14,    15,
      16,    17,     0,     0,     0,    18,     0,     0,    19,    20,
       0,     0,    21,     0,    25,     0,     0,     0,    26,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    27,
       0,     0,    28,     0,     0,     0,     0,   -90,     0,     0,
       0,     0,     0,     0,     0,    25,     0,     0,     0,    26,
       0,   -35,   -35,     0,     0,     0,     0,     0,     0,     0,
      27,     0,     0,    28,     0,     0,     0,   590,   -90,     2,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
       0,     0,   -35,    13,   -35,    14,    15,    16,    17,     0,
       0,   -35,    18,     0,     0,    19,    20,     0,   645,    21,
       2,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,     0,     0,   -35,    13,     0,    14,    15,    16,    17,
       0,     0,     0,    18,     0,     0,    19,    20,   -35,   -35,
      21,     0,    25,     0,     0,     0,    26,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    27,     0,     0,
      28,     0,     0,     0,     0,   -90,     0,     0,     0,     0,
       0,     0,     0,    25,     0,     0,     0,    26,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    27,     0,
       0,    28,     0,     0,     0,   669,   -90,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,     0,     0,
     -35,    13,     0,    14,    15,    16,    17,     0,     0,     0,
      18,     0,     0,    19,    20,   -35,   -35,    21,     0,   487,
       0,     2,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,     0,     0,   -35,    13,     0,    14,    15,    16,
      17,     0,     0,     0,    18,     0,     0,    19,    20,     0,
      25,    21,     0,     0,    26,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    27,     0,     0,    28,     0,
       0,     0,     0,   -90,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    25,     0,     0,     0,    26,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    27,
       0,     0,    28,     0,     0,     0,   540,   -90,     2,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,     0,
       0,   -35,    13,     0,    14,    15,    16,    17,     0,     0,
       0,    18,     0,     0,    19,    20,     0,   577,    21,     2,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
       0,     0,   -35,    13,     0,    14,    15,    16,    17,     0,
       0,     0,    18,     0,     0,    19,    20,     0,     0,    21,
       0,    25,     0,     0,     0,    26,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    27,     0,     0,    28,
       0,     0,     0,     0,   -90,     0,     0,     0,     0,     0,
       0,     0,    25,     0,     0,     0,    26,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    27,     0,     0,
      28,     0,     0,     0,   618,   -90,     2,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,     0,     0,   -35,
      13,     0,    14,    15,    16,    17,     0,     0,     0,    18,
       0,     0,    19,    20,     0,    58,    21,  -181,  -181,  -181,
    -181,  -181,  -181,  -181,  -181,  -181,  -181,     0,  -181,  -181,
    -181,     0,  -181,  -181,     0,     0,  -181,     0,     0,  -181,
    -181,     0,     0,  -181,     0,     0,     0,     0,     0,    25,
       0,     0,     0,    26,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    27,     0,     0,    28,     0,     0,
       0,     0,   -90,     0,     0,     0,     0,     0,     0,     0,
    -181,     0,     0,     0,  -181,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  -181,     0,     0,  -181,     0,
       0,    72,    59,  -181,     2,     3,     4,    60,    61,    62,
      63,    64,    65,    66,     0,   -90,   -90,   -90,     0,     0,
      14,     0,     0,    17,     0,     0,     0,    18,     0,     0,
      67,    73,    74,   288,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,     0,     0,     0,   289,    86,
      87,    88,    89,     0,     0,     0,    90,     0,     0,    91,
     290,    92,    25,    93,    94,    72,     0,    25,     0,     0,
       0,    26,     0,    95,    96,    97,     0,     0,     0,     0,
       0,     0,    27,     0,   291,    28,    98,    99,   100,     0,
      68,     0,     0,     0,     0,    73,    74,     0,    75,    76,
      77,   283,    79,    80,    81,    82,   284,    84,   285,     0,
       0,     0,     0,    86,    87,    88,    89,     0,     0,     0,
      90,   286,     0,    91,    72,    92,    25,    93,    94,     0,
       0,     0,     0,     0,     0,     0,     0,    95,    96,    97,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      98,    99,   100,     0,    73,    74,     0,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,     0,     0,
       0,     0,    86,    87,    88,    89,     0,     0,     0,    90,
       0,     0,    91,    72,    92,    25,    93,    94,     0,     0,
       0,     0,     0,     0,   579,     0,    95,    96,    97,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    98,
      99,   100,     0,    73,    74,     0,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,     0,     0,     0,
       0,    86,    87,    88,    89,     0,     0,     0,    90,     0,
       0,    91,    72,    92,    25,    93,    94,     0,     0,     0,
       0,     0,     0,     0,     0,    95,    96,    97,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    98,    99,
     100,     0,    73,    74,     0,    75,    76,    77,   156,    79,
      80,    81,    82,     0,    84,     0,     0,     0,     0,     0,
      86,    87,    88,    89,     0,     0,     0,    90,     0,     0,
      91,   157,    92,    25,    93,    94,    72,     0,     0,     0,
       0,     0,     0,     0,    95,    96,    97,     0,     0,     0,
       0,     0,     0,     0,     0,   158,     0,    98,    99,   100,
       0,     0,     0,     0,     0,     0,    73,    74,     0,    75,
      76,    77,     0,    79,    80,    81,    82,     0,    84,     0,
       0,     0,     0,     0,    86,    87,    88,    89,     0,     0,
       0,    90,     0,     0,    91,   269,    92,    25,    93,    94,
     161,     0,     0,     0,     0,     0,     0,     0,    95,    96,
      97,     0,     0,     0,     0,     0,     0,     0,     0,   270,
       0,    98,    99,   100,     0,     0,     0,     0,     0,     0,
      73,    74,     0,    75,    76,    77,   162,    79,    80,    81,
     163,     0,   164,     0,     0,     0,     0,     0,   165,   166,
     167,   168,     0,     0,     0,   169,     0,     0,    72,   170,
       0,    25,    93,    94,     0,     0,     0,     0,     0,     0,
       0,     0,   171,   172,   173,     0,     0,     0,     0,     0,
       0,     0,     0,   174,     0,    98,    99,   100,    73,    74,
       0,    75,    76,    77,     0,    79,    80,    81,    82,     0,
      84,     0,     0,     0,     0,     0,    86,    87,    88,    89,
       0,     0,     0,    90,     0,     0,    91,    72,    92,    25,
      93,    94,     0,   425,     0,     0,     0,     0,     0,     0,
      95,    96,    97,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    98,    99,   100,     0,    73,    74,     0,
      75,    76,    77,     0,    79,    80,    81,    82,     0,    84,
       0,     0,     0,     0,     0,    86,    87,    88,    89,     0,
       0,     0,    90,     0,     0,    91,    72,    92,    25,    93,
      94,     0,     0,     0,     0,     0,     0,     0,     0,    95,
      96,    97,     0,     0,     0,     0,     0,     0,     0,     0,
     447,     0,    98,    99,   100,     0,    73,    74,     0,    75,
      76,    77,     0,    79,    80,    81,    82,     0,    84,     0,
       0,     0,     0,     0,    86,    87,    88,    89,     0,     0,
       0,    90,     0,     0,    91,    72,    92,    25,    93,    94,
       0,     0,     0,     0,     0,     0,     0,     0,    95,    96,
      97,     0,     0,     0,     0,     0,     0,     0,     0,   449,
       0,    98,    99,   100,     0,    73,    74,     0,    75,    76,
      77,   506,    79,    80,    81,    82,     0,    84,     0,     0,
       0,     0,     0,    86,    87,    88,    89,     0,     0,     0,
      90,     0,     0,    91,    72,    92,    25,    93,    94,     0,
       0,     0,     0,     0,     0,     0,     0,    95,    96,    97,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      98,    99,   100,     0,    73,    74,     0,    75,    76,    77,
       0,    79,    80,    81,    82,     0,    84,     0,     0,     0,
       0,     0,    86,    87,    88,    89,     0,     0,     0,    90,
       0,     0,    91,   161,    92,    25,    93,    94,     0,     0,
       0,     0,     0,     0,     0,     0,    95,    96,    97,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    98,
      99,   100,     0,    73,    74,     0,    75,    76,    77,     0,
      79,    80,    81,   163,     0,   164,     0,     0,     0,     0,
       0,   165,   166,   167,   168,     0,     0,     0,   169,     0,
       0,   161,     0,     0,    25,    93,    94,     0,     0,     0,
       0,     0,     0,     0,     0,   171,   172,   173,     0,     0,
       0,     0,     0,     0,     0,     0,   386,     0,    98,    99,
     100,    73,    74,     0,    75,    76,    77,     0,    79,    80,
      81,   163,     0,   164,     0,     0,     0,     0,     0,   165,
     166,   167,   168,     0,     0,     0,   169,     0,     0,     0,
       0,     0,    25,    93,    94,     0,     0,     0,     0,     0,
       0,     0,     0,   171,   172,   173,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    98,    99,   100,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,     0,   315,     0,   316,   317,   476,   318,     0,
       0,     0,     0,     0,     0,   319,   320,   321,   322,   323,
       2,     3,     4,    60,    61,    62,    63,    64,    65,    66,
       0,     0,     0,     0,     0,     0,    14,     0,     0,    17,
       0,     0,     0,    18,     0,     0,    67,     0,     0,     0,
       0,     0,    25,    93,    94,     0,   324,     0,   325,   326,
       0,     0,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,  -162,   315,     0,   316,   317,
       0,   318,     0,    25,     0,     0,     0,    26,   319,   320,
     321,   322,   323,     0,     0,     0,     0,     0,    27,     0,
       0,    28,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    25,    93,    94,     0,   324,
       0,   325,   326
};

static const yytype_int16 yycheck[] =
{
       7,     8,     9,    15,    85,   318,   195,    19,   332,   147,
      49,   134,     1,    20,     1,   557,    24,     5,   100,     7,
       8,     9,    64,    27,     1,     1,     1,    64,   486,     1,
       5,    82,    83,   646,     1,    80,     1,    82,     1,     5,
       5,    59,    92,    93,     3,     4,    88,     1,    99,    89,
       1,    88,    75,    24,     0,    67,     4,   670,     1,     5,
      78,     7,     8,     9,    14,    15,    24,    26,    89,    21,
      74,    24,    60,    25,    62,    63,    64,    66,     1,    66,
      24,     0,    59,   164,    30,     5,    89,    59,   546,    83,
     632,   633,    24,   635,    59,    70,    59,    75,     1,    66,
     122,     4,   124,    49,   126,    59,    54,     0,   627,   628,
      24,    59,   163,    89,    60,    66,    62,    63,    64,    91,
      68,    93,    81,    66,    78,    71,   134,   134,    91,    75,
      76,    77,   139,   591,    80,    81,     4,   679,    75,   681,
     682,    93,   146,    66,    92,    93,   150,    75,   472,    53,
      75,    54,    98,    75,   478,    80,    59,    82,   471,    31,
      32,   485,   170,   476,   172,    68,   174,    71,    24,   163,
     251,    59,   254,    14,    15,    16,   122,    81,   124,    75,
     126,    10,    11,    12,    75,    14,    54,   195,    17,    92,
      75,    59,   243,   244,    75,   141,    75,     1,    75,   170,
      68,   172,    75,   174,   285,   328,    75,    37,    75,    75,
     333,   334,   170,    42,   172,   404,   174,   170,   531,   172,
     358,   174,    52,    74,   212,   213,   170,    91,   172,    92,
     174,    89,    61,   284,    64,    74,    65,    66,   170,     5,
     172,   193,   174,    76,    75,    75,   570,    71,   141,   243,
     244,    59,    52,    57,    58,    74,   170,    52,    88,   298,
     174,    16,    66,    16,    64,    18,   212,   213,    75,    75,
      74,    75,    25,    75,    75,   282,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    75,    75,    53,    88,    75,
     284,   298,   299,   300,   282,    16,   335,    18,   337,    75,
      66,    67,    68,    75,    25,    71,    75,    37,   621,    16,
      89,   299,   264,   301,   170,    81,   172,    37,   174,    89,
     328,    16,    52,    16,   332,   333,   334,   334,   258,   259,
     337,    16,    52,   340,    64,    82,   282,    71,   268,    80,
      81,    82,    71,   273,    64,    75,   657,   658,   429,   660,
      16,    16,   298,   299,    16,   301,    18,    71,    88,   363,
     364,   365,    75,    25,     1,   369,   318,   406,    88,   408,
      16,   379,    18,    16,   382,   383,    16,   385,   386,    25,
      72,   389,   700,   701,    75,   703,   697,   698,   699,   335,
     336,   337,   382,   383,    71,   385,   403,    24,    16,   389,
      14,    15,    16,    75,   411,   412,   413,   725,   379,   727,
     728,   382,   383,    73,   385,   386,    75,   405,   389,   407,
     442,   379,    75,    16,   382,   383,   379,   385,   386,   382,
     383,   389,   385,   386,   456,   379,   389,    75,   382,   383,
      16,   385,   386,   336,    75,   389,    16,   379,    16,    75,
     382,   383,    75,   385,   386,    75,    16,   389,    16,   405,
     406,   407,   408,    24,   472,   379,    75,    75,   475,   476,
     478,    24,   386,    80,    81,    82,    75,   485,    16,   491,
      24,   310,   311,   312,   391,   492,   315,   316,   317,    30,
     319,    47,   321,   707,   323,   234,   442,   713,   714,   154,
     716,   509,   510,   358,   526,   527,   498,    -1,   454,    24,
     456,   457,    -1,    -1,   730,   731,   732,    -1,    -1,   471,
      -1,    -1,    -1,   379,   476,    -1,   382,   383,    -1,   385,
     386,    -1,    -1,   389,    -1,    -1,    -1,    -1,   509,   510,
      -1,    -1,    -1,   170,   490,   172,    -1,   174,   494,   557,
      -1,   509,   510,    -1,    -1,    -1,   509,   510,    -1,    -1,
     567,   454,   570,    -1,   457,   509,   510,    -1,   575,    -1,
      -1,    -1,   579,    -1,    -1,   582,   522,   509,   510,   531,
     526,   527,    23,    24,    25,    26,    27,    28,    -1,    -1,
     597,   598,   599,    -1,   601,   509,   510,   490,    -1,   606,
     607,   494,    -1,    -1,   643,   612,    -1,    -1,   615,   170,
     617,   172,    -1,   174,    -1,    -1,   623,   170,    -1,   172,
      -1,   174,    -1,    -1,   632,   633,   170,   635,   172,   522,
     174,    -1,   640,    -1,   641,   581,    23,    24,    25,    26,
      27,    28,   649,   631,    -1,    -1,    -1,    -1,   655,     7,
       8,     9,    -1,   509,   510,   170,    -1,   172,    -1,   174,
      -1,    -1,    -1,    -1,   671,    -1,   673,   674,    -1,   621,
     616,   679,    -1,   681,   682,    -1,   683,   684,    -1,   686,
      -1,   627,   628,    -1,    -1,   631,    -1,    -1,   581,    -1,
      -1,    -1,   700,   701,    -1,   703,    -1,   643,    -1,   706,
      -1,   647,   709,    -1,    62,    63,    64,    -1,   715,    -1,
     717,   718,    -1,    -1,   721,    -1,    -1,   725,    -1,   727,
     728,   550,    -1,   616,    -1,    -1,   672,    -1,    -1,   675,
      -1,    -1,    -1,    -1,   627,   628,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    23,    -1,   574,   692,    -1,    -1,   695,
      -1,    -1,   379,    -1,   647,   382,   383,    -1,   385,   386,
      57,    58,   389,    -1,    -1,    -1,    -1,    -1,    -1,    66,
      -1,    -1,    -1,   602,    -1,    -1,    -1,    -1,    75,   672,
      -1,    -1,   675,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    -1,    -1,    -1,   624,    -1,    -1,    -1,   692,
      -1,    -1,   695,    -1,    -1,   634,    -1,   636,   637,    -1,
      -1,    91,    92,    -1,    94,    -1,    96,    -1,   379,    -1,
      -1,   382,   383,    -1,   385,   386,   379,    -1,   389,   382,
     383,    -1,   385,   386,   114,   379,   389,    -1,   382,   383,
      -1,   385,   386,    -1,    -1,   389,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     1,   212,   213,   685,     5,   687,   688,
      -1,    -1,    -1,    -1,   379,    -1,    -1,   382,   383,    -1,
     385,   386,    -1,    -1,   389,    -1,    -1,   157,   158,    -1,
       1,    -1,   509,   510,    -1,    -1,    -1,    35,    36,    -1,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    -1,    -1,    -1,    -1,    53,    54,    55,    56,    -1,
     190,   191,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    -1,    -1,    -1,   282,    -1,    -1,    75,    -1,    77,
      78,    79,    -1,    -1,    -1,    -1,    57,    58,    -1,    -1,
      88,   299,    90,    91,    92,    66,    67,    -1,   509,   510,
     230,    -1,    -1,    74,    -1,    76,   509,   510,    -1,    80,
      81,    82,    83,    -1,    -1,   509,   510,    88,    -1,   249,
      -1,    -1,    -1,    57,    -1,    -1,    -1,    -1,   258,   259,
      -1,    -1,    66,    -1,    -1,    -1,    -1,    -1,   268,   269,
     270,    75,    -1,   273,   509,   510,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    -1,   286,    -1,   288,   289,
     290,   291,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,    -1,     5,
       1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    -1,    -1,   324,    -1,    -1,   405,    19,   407,
      -1,    22,    -1,    -1,    -1,    26,    -1,    -1,    29,    35,
      36,    -1,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,     1,    -1,    -1,    -1,    53,    54,    55,
      56,    -1,    -1,    -1,    60,    -1,    -1,    63,    -1,    65,
      66,    67,    68,   373,    -1,    66,   376,    -1,    74,    70,
      -1,    77,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,
      81,   391,    88,    84,    90,    91,    92,    -1,    89,    -1,
      -1,    -1,    -1,    -1,    -1,    57,    58,    -1,    -1,    57,
      58,    -1,    -1,    -1,    66,    67,    -1,     1,    66,    67,
      -1,     5,    74,    -1,    76,   425,    74,    -1,    76,    -1,
      -1,    83,    80,    81,    82,    83,    88,    -1,    -1,    -1,
      88,    -1,    -1,   443,    -1,    -1,    -1,   447,    -1,   449,
      -1,    35,    36,    -1,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    -1,    -1,    -1,    -1,    53,
      54,    55,    56,    -1,    -1,    -1,    60,    -1,    -1,    63,
      -1,    65,    66,    67,    68,     1,    -1,    -1,    -1,     5,
      -1,    75,    -1,    77,    78,    79,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   503,   504,    89,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,
      36,    -1,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    -1,    -1,    -1,    -1,    53,    54,    55,
      56,    -1,    -1,    -1,    60,    -1,    -1,    63,    -1,    65,
      66,    67,    68,     1,    -1,    -1,    -1,     5,    -1,    75,
      -1,    77,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,    36,    -1,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    -1,    -1,    -1,    -1,    53,    54,    55,    56,    -1,
      -1,    -1,    60,    -1,    -1,    63,    -1,    65,    66,    67,
      68,     1,    -1,    -1,    -1,     5,    -1,    75,    -1,    77,
      78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    35,    36,    -1,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    -1,
      -1,    -1,    -1,    53,    54,    55,    56,    -1,    -1,    -1,
      60,    -1,    -1,    63,    -1,    65,    66,    67,    68,     1,
      -1,    -1,    -1,     5,    -1,    75,    -1,    77,    78,    79,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    35,    36,    -1,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    -1,    -1,    -1,
      -1,    53,    54,    55,    56,    -1,    -1,    -1,    60,    -1,
      -1,    63,    -1,    65,    66,    67,    68,     1,    -1,    -1,
      -1,     5,    -1,    75,    -1,    77,    78,    79,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    35,    36,    -1,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    -1,    -1,    -1,    -1,    53,
      54,    55,    56,    -1,    -1,    -1,    60,    -1,    -1,    63,
      -1,    65,    66,    67,    68,     1,    -1,    -1,    -1,     5,
      -1,    75,    -1,    77,    78,    79,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    90,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,
      36,    -1,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    -1,    -1,    -1,    -1,    53,    54,    55,
      56,    -1,    -1,    -1,    60,    -1,    -1,    63,    -1,    65,
      66,    67,    68,     1,    -1,    -1,    -1,     5,    -1,    75,
      -1,    77,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    90,    91,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,    36,    -1,
      38,    39,    40,    -1,    42,    43,    44,    45,    -1,    47,
      -1,    -1,    -1,    -1,    -1,    53,    54,    55,    56,    -1,
      -1,    -1,    60,    -1,    -1,    63,    -1,    65,    66,    67,
      68,     1,    -1,    -1,    -1,     5,    -1,    -1,    -1,    77,
      78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    35,    36,    -1,    38,    39,
      40,    -1,    42,    43,    44,    45,    -1,    47,    -1,    -1,
      -1,    -1,    -1,    53,    54,    55,    56,    -1,    -1,    -1,
      60,    -1,    -1,    63,    -1,    65,    66,    67,    68,    -1,
      -1,    -1,    -1,     1,    -1,    -1,    -1,    77,    78,    79,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    91,    92,     0,     1,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    -1,    -1,
      17,    -1,    19,    20,    21,    22,    -1,    -1,    -1,    26,
      -1,    -1,    29,    30,    -1,    -1,    33,    -1,    -1,    57,
      58,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    66,    67,
      -1,    -1,    49,    50,    51,    -1,    74,    75,    76,    -1,
      -1,    -1,    80,    -1,    82,    83,    -1,    -1,    -1,    66,
      88,    -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    81,    -1,    -1,    84,    -1,    -1,
      -1,     1,    89,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    -1,    19,
      20,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    57,    58,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    66,    67,    -1,    -1,    -1,    -1,    -1,
      -1,    74,    -1,    76,    -1,    -1,    -1,    -1,    -1,    -1,
      83,    84,    85,    86,    87,    88,    66,    67,    68,    -1,
      70,    -1,    72,    73,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,    89,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    -1,    19,    20,    21,    22,
      -1,    -1,    -1,    -1,    -1,    -1,    29,    30,    31,    32,
      33,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    66,    67,    68,    -1,    70,    -1,    72,
      73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     1,    89,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    -1,    -1,    25,
      26,    -1,    -1,    29,    30,    -1,     1,    33,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    -1,    17,    -1,    19,    20,    21,    22,    -1,    -1,
      -1,    -1,    -1,    -1,    29,    30,    31,    32,    33,    -1,
      66,    -1,    -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    81,    -1,    -1,    84,    -1,
      -1,    -1,    -1,    89,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    66,    67,    68,    -1,    70,    -1,    72,    73,     1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    89,    17,    -1,    19,    20,    21,
      22,    -1,    -1,    -1,    -1,    -1,    -1,    29,    30,    31,
      32,    33,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    -1,    -1,    17,    -1,    19,    20,
      21,    22,    -1,    -1,    -1,    26,    -1,    -1,    29,    30,
      -1,    -1,    33,    -1,    66,    67,    68,    -1,    70,    -1,
      72,    73,     1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    89,    17,    -1,
      19,    20,    21,    22,    -1,    66,    -1,    -1,    -1,    70,
      29,    30,    31,    32,    33,    -1,    -1,    -1,    -1,    -1,
      81,    -1,    -1,    84,    -1,    -1,    -1,    -1,    89,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    66,    67,    68,
      -1,    70,    -1,    72,    73,     1,    -1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      89,    17,    -1,    19,    20,    -1,    22,    -1,    -1,    -1,
      -1,    -1,    -1,    29,    30,    31,    32,    33,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      66,    67,    68,    -1,    70,    -1,    72,    73,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     1,    89,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    -1,
      19,    20,    21,    22,    -1,    -1,    -1,    26,    -1,    -1,
      29,    30,    -1,     1,    33,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      -1,    19,    20,    21,    22,    -1,    -1,    -1,    26,    -1,
      -1,    29,    30,    -1,    -1,    33,    -1,    66,    -1,    -1,
      -1,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    81,    -1,    -1,    84,    -1,    -1,    -1,    -1,
      89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    66,    -1,
      -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    81,    -1,    -1,    84,    -1,    -1,    -1,
       1,    89,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    -1,    19,    20,
      21,    22,    -1,    -1,    -1,    26,    -1,    -1,    29,    30,
      -1,     1,    33,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    -1,    19,
      20,    21,    22,    -1,    -1,    -1,    26,    -1,    -1,    29,
      30,    -1,    -1,    33,    -1,    66,    -1,    -1,    -1,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      81,    -1,    -1,    84,    -1,    -1,    -1,    -1,    89,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    66,    -1,    -1,    -1,
      70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    81,    -1,    -1,    84,    -1,    -1,    -1,     1,    89,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    -1,    16,    17,    -1,    19,    20,    21,    22,
      -1,    -1,    -1,    26,    -1,    -1,    29,    30,    31,    32,
      33,    -1,     1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    -1,
      19,    20,    21,    22,    -1,    -1,    -1,    26,    -1,    -1,
      29,    30,    -1,    66,    33,    -1,    -1,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    81,    -1,
      -1,    84,    -1,    -1,    -1,    -1,    89,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    66,    -1,    -1,
      -1,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    81,    -1,    -1,    84,    -1,    -1,    -1,     1,
      89,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    -1,    19,    20,    21,
      22,    -1,    -1,    -1,    26,    -1,    -1,    29,    30,    -1,
       1,    33,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    -1,    16,    17,    -1,    19,    20,
      21,    22,    -1,    -1,    -1,    26,    -1,    -1,    29,    30,
      -1,    -1,    33,    -1,    66,    -1,    -1,    -1,    70,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    81,
      -1,    -1,    84,    -1,    -1,    -1,    -1,    89,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    66,    -1,    -1,    -1,    70,
      -1,    72,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      81,    -1,    -1,    84,    -1,    -1,    -1,     1,    89,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    -1,    16,    17,    18,    19,    20,    21,    22,    -1,
      -1,    25,    26,    -1,    -1,    29,    30,    -1,     1,    33,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    -1,    16,    17,    -1,    19,    20,    21,    22,
      -1,    -1,    -1,    26,    -1,    -1,    29,    30,    31,    32,
      33,    -1,    66,    -1,    -1,    -1,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    81,    -1,    -1,
      84,    -1,    -1,    -1,    -1,    89,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    66,    -1,    -1,    -1,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    81,    -1,
      -1,    84,    -1,    -1,    -1,     1,    89,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    -1,
      16,    17,    -1,    19,    20,    21,    22,    -1,    -1,    -1,
      26,    -1,    -1,    29,    30,    31,    32,    33,    -1,     1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    -1,    16,    17,    -1,    19,    20,    21,
      22,    -1,    -1,    -1,    26,    -1,    -1,    29,    30,    -1,
      66,    33,    -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    81,    -1,    -1,    84,    -1,
      -1,    -1,    -1,    89,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    66,    -1,    -1,    -1,    70,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    81,
      -1,    -1,    84,    -1,    -1,    -1,     1,    89,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      -1,    16,    17,    -1,    19,    20,    21,    22,    -1,    -1,
      -1,    26,    -1,    -1,    29,    30,    -1,     1,    33,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    -1,    16,    17,    -1,    19,    20,    21,    22,    -1,
      -1,    -1,    26,    -1,    -1,    29,    30,    -1,    -1,    33,
      -1,    66,    -1,    -1,    -1,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    81,    -1,    -1,    84,
      -1,    -1,    -1,    -1,    89,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    66,    -1,    -1,    -1,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    81,    -1,    -1,
      84,    -1,    -1,    -1,     1,    89,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    -1,    16,
      17,    -1,    19,    20,    21,    22,    -1,    -1,    -1,    26,
      -1,    -1,    29,    30,    -1,     1,    33,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    -1,    14,    15,
      16,    -1,    18,    19,    -1,    -1,    22,    -1,    -1,    25,
      26,    -1,    -1,    29,    -1,    -1,    -1,    -1,    -1,    66,
      -1,    -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    81,    -1,    -1,    84,    -1,    -1,
      -1,    -1,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      66,    -1,    -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    81,    -1,    -1,    84,    -1,
      -1,     5,     1,    89,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    -1,    14,    15,    16,    -1,    -1,
      19,    -1,    -1,    22,    -1,    -1,    -1,    26,    -1,    -1,
      29,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    -1,    -1,    -1,    52,    53,
      54,    55,    56,    -1,    -1,    -1,    60,    -1,    -1,    63,
      64,    65,    66,    67,    68,     5,    -1,    66,    -1,    -1,
      -1,    70,    -1,    77,    78,    79,    -1,    -1,    -1,    -1,
      -1,    -1,    81,    -1,    88,    84,    90,    91,    92,    -1,
      89,    -1,    -1,    -1,    -1,    35,    36,    -1,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    -1,
      -1,    -1,    -1,    53,    54,    55,    56,    -1,    -1,    -1,
      60,    61,    -1,    63,     5,    65,    66,    67,    68,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,    78,    79,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    91,    92,    -1,    35,    36,    -1,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    -1,    -1,
      -1,    -1,    53,    54,    55,    56,    -1,    -1,    -1,    60,
      -1,    -1,    63,     5,    65,    66,    67,    68,    -1,    -1,
      -1,    -1,    -1,    -1,    75,    -1,    77,    78,    79,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,
      91,    92,    -1,    35,    36,    -1,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    -1,    -1,    -1,
      -1,    53,    54,    55,    56,    -1,    -1,    -1,    60,    -1,
      -1,    63,     5,    65,    66,    67,    68,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    77,    78,    79,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    -1,    35,    36,    -1,    38,    39,    40,    41,    42,
      43,    44,    45,    -1,    47,    -1,    -1,    -1,    -1,    -1,
      53,    54,    55,    56,    -1,    -1,    -1,    60,    -1,    -1,
      63,    64,    65,    66,    67,    68,     5,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    77,    78,    79,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    88,    -1,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    35,    36,    -1,    38,
      39,    40,    -1,    42,    43,    44,    45,    -1,    47,    -1,
      -1,    -1,    -1,    -1,    53,    54,    55,    56,    -1,    -1,
      -1,    60,    -1,    -1,    63,    64,    65,    66,    67,    68,
       5,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,    78,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    88,
      -1,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,
      35,    36,    -1,    38,    39,    40,    41,    42,    43,    44,
      45,    -1,    47,    -1,    -1,    -1,    -1,    -1,    53,    54,
      55,    56,    -1,    -1,    -1,    60,    -1,    -1,     5,    64,
      -1,    66,    67,    68,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    77,    78,    79,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    88,    -1,    90,    91,    92,    35,    36,
      -1,    38,    39,    40,    -1,    42,    43,    44,    45,    -1,
      47,    -1,    -1,    -1,    -1,    -1,    53,    54,    55,    56,
      -1,    -1,    -1,    60,    -1,    -1,    63,     5,    65,    66,
      67,    68,    -1,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      77,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    90,    91,    92,    -1,    35,    36,    -1,
      38,    39,    40,    -1,    42,    43,    44,    45,    -1,    47,
      -1,    -1,    -1,    -1,    -1,    53,    54,    55,    56,    -1,
      -1,    -1,    60,    -1,    -1,    63,     5,    65,    66,    67,
      68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,
      78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      88,    -1,    90,    91,    92,    -1,    35,    36,    -1,    38,
      39,    40,    -1,    42,    43,    44,    45,    -1,    47,    -1,
      -1,    -1,    -1,    -1,    53,    54,    55,    56,    -1,    -1,
      -1,    60,    -1,    -1,    63,     5,    65,    66,    67,    68,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,    78,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    88,
      -1,    90,    91,    92,    -1,    35,    36,    -1,    38,    39,
      40,    41,    42,    43,    44,    45,    -1,    47,    -1,    -1,
      -1,    -1,    -1,    53,    54,    55,    56,    -1,    -1,    -1,
      60,    -1,    -1,    63,     5,    65,    66,    67,    68,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,    78,    79,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    91,    92,    -1,    35,    36,    -1,    38,    39,    40,
      -1,    42,    43,    44,    45,    -1,    47,    -1,    -1,    -1,
      -1,    -1,    53,    54,    55,    56,    -1,    -1,    -1,    60,
      -1,    -1,    63,     5,    65,    66,    67,    68,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    77,    78,    79,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,
      91,    92,    -1,    35,    36,    -1,    38,    39,    40,    -1,
      42,    43,    44,    45,    -1,    47,    -1,    -1,    -1,    -1,
      -1,    53,    54,    55,    56,    -1,    -1,    -1,    60,    -1,
      -1,     5,    -1,    -1,    66,    67,    68,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    77,    78,    79,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    88,    -1,    90,    91,
      92,    35,    36,    -1,    38,    39,    40,    -1,    42,    43,
      44,    45,    -1,    47,    -1,    -1,    -1,    -1,    -1,    53,
      54,    55,    56,    -1,    -1,    -1,    60,    -1,    -1,    -1,
      -1,    -1,    66,    67,    68,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    77,    78,    79,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    90,    91,    92,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    -1,    17,    -1,    19,    20,    21,    22,    -1,
      -1,    -1,    -1,    -1,    -1,    29,    30,    31,    32,    33,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,    22,
      -1,    -1,    -1,    26,    -1,    -1,    29,    -1,    -1,    -1,
      -1,    -1,    66,    67,    68,    -1,    70,    -1,    72,    73,
      -1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    89,    17,    -1,    19,    20,
      -1,    22,    -1,    66,    -1,    -1,    -1,    70,    29,    30,
      31,    32,    33,    -1,    -1,    -1,    -1,    -1,    81,    -1,
      -1,    84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    66,    67,    68,    -1,    70,
      -1,    72,    73
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     1,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    17,    19,    20,    21,    22,    26,    29,
      30,    33,    49,    50,    51,    66,    70,    81,    84,    95,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   120,   121,   125,   128,   129,   130,   131,   132,   133,
     136,   137,   139,   151,   152,   162,   185,    89,     1,     1,
       6,     7,     8,     9,    10,    11,    12,    29,    89,   129,
     134,   195,     5,    35,    36,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    53,    54,    55,    56,
      60,    63,    65,    67,    68,    77,    78,    79,    90,    91,
      92,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   178,   186,   196,   197,   198,
     205,   134,   195,   134,   195,   134,   195,     1,   167,   167,
     167,     1,   167,     1,    75,   166,     1,   167,     1,    75,
     166,   195,   168,   183,    57,    58,    66,    67,    74,    76,
      83,    88,   187,   188,   189,   194,    41,    64,    88,    98,
     178,     5,    41,    45,    47,    53,    54,    55,    56,    60,
      64,    77,    78,    79,    88,   102,   156,   157,   158,   159,
     160,   161,   165,   172,   186,   196,   197,   198,   205,     1,
      61,    62,    75,    88,   168,     5,     1,   187,     0,   109,
     167,    89,   132,   130,     1,     5,    70,    89,   167,   167,
     167,   166,    14,    15,    16,   135,     1,   108,   123,     1,
       5,    59,     1,   187,     1,   162,     1,   162,     1,   162,
     170,     1,    59,    78,   206,   207,     1,   162,     1,   162,
       1,    59,    91,    93,   201,   203,   203,     4,    54,    68,
      92,    93,   155,   199,   200,   201,   204,   204,   182,   181,
     178,   178,     1,    74,    88,   168,     1,   178,   180,    64,
      88,   178,   184,   179,     1,   162,     1,    91,   201,     1,
      92,   199,    75,    41,    46,    48,    61,   178,    37,    52,
      64,    88,     1,   123,     1,   123,     1,   123,    75,    75,
      75,    75,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    17,    19,    20,    22,    29,
      30,    31,    32,    33,    70,    72,    73,   147,   148,   149,
     154,   165,   195,   208,    75,    75,   195,    75,     1,   108,
      75,     1,   187,     1,    57,    66,    74,    75,    80,    81,
      82,    83,    84,    85,    86,    87,    88,   190,   191,   192,
     193,   194,   187,    80,    82,    83,    84,    85,    86,    87,
     188,    64,    88,    99,   178,   178,    96,    64,    88,   103,
     203,   204,   176,   175,   172,   174,    88,   172,   177,   173,
     172,    97,   178,   178,   168,    75,     5,    53,    71,   153,
     165,   185,    81,    75,     5,    75,    75,    75,    75,   134,
     134,    14,    15,    16,   124,    81,   178,     1,    59,    78,
     207,    59,   202,   203,   203,    70,   178,   204,    92,    93,
     199,   184,   184,   168,    74,   184,   178,   178,   184,    91,
      92,   134,   195,   171,   203,   204,   178,    88,   178,    88,
     178,   178,   178,   130,   195,   134,   195,   195,   129,     1,
     167,   167,   167,   167,   167,   167,     1,   183,   167,   167,
     167,   178,    89,   147,     1,    16,    21,   140,   141,   142,
     145,   146,   147,   147,   147,   195,   130,     1,   108,   130,
     195,    31,    32,   138,   195,    75,    74,   190,    76,   187,
     187,   187,   187,   101,   100,   178,    41,   106,   178,   105,
     104,   172,   177,   177,   177,   172,   177,   106,    75,    75,
      75,    71,   195,    53,    71,   185,   195,   195,   195,    59,
       1,   178,   204,    74,     1,   123,   178,   178,   178,    16,
       1,   108,     1,   123,     1,   108,   118,    16,    18,    25,
     122,    75,    75,    75,    75,    75,    75,    75,    75,    75,
      75,   183,     1,   140,   195,   183,   195,    16,   140,    89,
      89,     1,   140,    16,   122,    16,    16,     1,   108,    75,
     166,   195,    16,     1,   108,   193,   178,   178,   172,   172,
       1,   108,    71,    71,   123,   123,   183,    16,    14,    15,
     119,    16,   122,   167,   146,    71,    16,    75,     1,   195,
       1,   140,    16,   167,   195,    16,   195,    75,     1,   108,
     195,    72,   126,    16,   122,    71,   195,   195,   195,   195,
     167,    75,    23,    24,    25,    26,    27,    28,   150,   195,
     195,    16,   195,    75,   195,     1,   108,   195,   183,    73,
     127,   195,   167,   118,   118,    75,   129,   146,   146,   167,
     146,   167,   167,    16,   140,   144,   195,   130,   138,     1,
     108,    75,   195,    16,    75,   195,    16,   150,   150,    75,
     150,    75,    75,    23,    24,    25,    26,    27,    28,   143,
      16,   138,   195,   108,   195,   195,   108,   146,   146,   146,
     195,   195,   167,   195,   167,   167,    16,   108,   108,    16,
     150,   150,   150,   144,   144,    75,   144,    75,    75,   195,
     126,    16,   195,   143,   143,   195,   143,   195,   195,   195,
     144,   144,   144,   143,   143,   143
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    94,    95,    95,    96,    95,    97,    95,    95,    95,
      95,    99,    98,   100,    98,   101,    98,    98,    98,    98,
     103,   102,   104,   102,   105,   102,   102,   102,   102,   106,
     106,   106,   107,   107,   108,   108,   109,   109,   109,   109,
     109,   109,   109,   109,   109,   109,   109,   109,   109,   109,
     110,   110,   111,   111,   112,   112,   113,   113,   114,   114,
     115,   115,   116,   116,   117,   117,   117,   118,   119,   119,
     119,   120,   120,   120,   121,   121,   122,   122,   123,   124,
     124,   124,   125,   125,   126,   126,   127,   127,   128,   129,
     129,   130,   130,   131,   131,   131,   131,   132,   132,   133,
     133,   133,   133,   133,   133,   133,   133,   133,   133,   133,
     133,   133,   133,   133,   133,   133,   133,   134,   135,   135,
     135,   136,   136,   136,   136,   136,   137,   137,   138,   138,
     138,   138,   138,   138,   138,   139,   139,   139,   139,   139,
     139,   139,   139,   139,   139,   140,   140,   141,   141,   142,
     142,   143,   143,   143,   143,   143,   143,   143,   144,   144,
     145,   146,   146,   147,   147,   147,   147,   148,   148,   148,
     148,   148,   149,   149,   150,   150,   150,   150,   150,   150,
     150,   151,   151,   151,   151,   151,   151,   151,   151,   151,
     152,   153,   153,   153,   153,   154,   154,   154,   155,   155,
     156,   156,   157,   157,   158,   158,   159,   159,   160,   160,
     161,   161,   162,   162,   162,   162,   162,   162,   163,   163,
     164,   164,   164,   164,   165,   165,   165,   166,   167,   167,
     168,   169,   170,   169,   171,   169,   169,   169,   169,   169,
     169,   169,   172,   172,   172,   172,   172,   172,   172,   172,
     172,   172,   172,   172,   172,   172,   172,   172,   172,   172,
     173,   172,   174,   172,   175,   172,   176,   172,   172,   177,
     177,   178,   178,   178,   178,   178,   178,   178,   178,   178,
     178,   178,   178,   178,   178,   178,   178,   178,   178,   179,
     178,   180,   178,   181,   178,   178,   178,   178,   178,   178,
     178,   178,   178,   182,   178,   178,   183,   183,   184,   184,
     184,   185,   185,   186,   186,   187,   187,   187,   187,   187,
     188,   188,   188,   189,   189,   189,   189,   189,   189,   189,
     189,   189,   189,   189,   189,   189,   189,   190,   190,   191,
     191,   191,   192,   193,   193,   193,   193,   193,   193,   193,
     193,   193,   193,   193,   193,   194,   195,   195,   196,   196,
     196,   197,   197,   197,   198,   198,   198,   199,   199,   200,
     200,   200,   200,   200,   201,   201,   202,   202,   203,   203,
     203,   203,   204,   204,   204,   204,   205,   205,   205,   206,
     206,   207,   207,   208,   208,   208,   208,   208,   208,   208,
     208,   208,   208,   208,   208,   208,   208,   208,   208,   208,
     208,   208,   208
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     2,     0,     4,     0,     4,     1,     1,
       2,     0,     3,     0,     4,     0,     4,     1,     2,     2,
       0,     3,     0,     4,     0,     4,     1,     2,     2,     1,
       1,     0,     1,     2,     1,     0,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     3,     5,     5,     3,     3,     3,     3,     3,     3,
       7,     5,     5,     5,     7,    12,     5,     2,     3,     3,
       0,     7,    12,     5,     1,     1,     1,     1,     2,     2,
       3,     3,     9,     5,     6,     0,     3,     0,     2,     1,
       0,     1,     2,     1,     1,     1,     1,     1,     2,     1,
       1,     1,     5,     9,     5,     9,     5,     2,     2,     2,
       2,     4,     2,     2,     2,     4,     5,     2,     1,     2,
       2,     7,     6,     2,     5,     4,     6,     3,     5,     6,
       3,     0,     4,     5,     3,     7,     5,     6,     7,     8,
       2,     5,     4,     6,     5,     1,     2,     1,     1,     8,
       3,     4,     4,     6,     4,     6,     6,     0,     1,     0,
       2,     1,     0,     1,     2,     1,     2,     1,     1,     1,
       1,     1,     6,     2,     3,     3,     5,     3,     5,     5,
       0,     1,     3,     4,     2,     4,     5,     5,     2,     2,
       1,     1,     1,     1,     1,     1,     4,     2,     5,     3,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     3,     4,     2,     4,     4,     2,     2,     2,
       4,     3,     2,     2,     1,     1,     1,     1,     1,     0,
       1,     1,     0,     3,     0,     4,     2,     3,     2,     3,
       2,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     2,     1,     2,
       0,     3,     0,     3,     0,     3,     0,     3,     1,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     2,     1,     2,     0,
       3,     0,     3,     0,     3,     3,     4,     3,     4,     3,
       3,     2,     2,     0,     3,     1,     1,     0,     2,     2,
       1,     3,     2,     3,     2,     1,     3,     3,     2,     0,
       1,     2,     3,     2,     2,     2,     3,     3,     2,     2,
       1,     1,     1,     1,     1,     3,     2,     1,     2,     1,
       1,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     2,     3,
       2,     2,     2,     2,     2,     3,     2,     1,     2,     1,
       1,     1,     1,     2,     1,     2,     1,     2,     1,     2,
       2,     1,     1,     2,     2,     3,     2,     3,     2,     2,
       1,     2,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     3,     3,     3,     3,     3,
       3,     3,     3
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (scnr, parser, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, scnr, parser); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep, scanner_t *scnr, parser_t *parser)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  YYUSE (scnr);
  YYUSE (parser);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yytype], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep, scanner_t *scnr, parser_t *parser)
{
  YYFPRINTF (yyo, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyo, yytype, yyvaluep, scnr, parser);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, int yyrule, scanner_t *scnr, parser_t *parser)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &yyvsp[(yyi + 1) - (yynrhs)]
                                              , scnr, parser);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, scnr, parser); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
#  else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                yy_state_t *yyssp, int yytoken)
{
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Actual size of YYARG. */
  int yycount = 0;
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      YYPTRDIFF_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
      yysize = yysize0;
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYPTRDIFF_T yysize1
                    = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
                    yysize = yysize1;
                  else
                    return 2;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    /* Don't count the "%s"s in the final size, but reserve room for
       the terminator.  */
    YYPTRDIFF_T yysize1 = yysize + (yystrlen (yyformat) - 2 * yycount) + 1;
    if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
      yysize = yysize1;
    else
      return 2;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, scanner_t *scnr, parser_t *parser)
{
  YYUSE (yyvaluep);
  YYUSE (scnr);
  YYUSE (parser);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (scanner_t *scnr, parser_t *parser)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

    /* Number of syntax errors so far.  */
    int yynerrs;

    yy_state_fast_t yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss;
    yy_state_t *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYPTRDIFF_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
# undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, scnr);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2:
#line 177 "parser.y"
                                { parser->syntax_tree = (yyvsp[0].val); }
#line 2817 "y.tab.c"
    break;

  case 3:
#line 178 "parser.y"
                                { parser->syntax_tree = (yyvsp[0].val); end_of_regex(scnr); }
#line 2823 "y.tab.c"
    break;

  case 4:
#line 180 "parser.y"
                                { parser->syntax_tree = (yyvsp[0].val); YYACCEPT; }
#line 2829 "y.tab.c"
    break;

  case 5:
#line 181 "parser.y"
                                { internal_error("notreached"); }
#line 2835 "y.tab.c"
    break;

  case 6:
#line 183 "parser.y"
                                { parser->syntax_tree = (yyvsp[0].val); YYACCEPT; }
#line 2841 "y.tab.c"
    break;

  case 7:
#line 184 "parser.y"
                                { internal_error("notreached"); }
#line 2847 "y.tab.c"
    break;

  case 8:
#line 185 "parser.y"
                                { if (yychar == YYEOF) {
                                    parser->syntax_tree = nao;
                                    YYACCEPT;
                                  } else {
                                    yybadtok(yychar, nil);
                                    parser->syntax_tree = nil;
                                  } }
#line 2859 "y.tab.c"
    break;

  case 9:
#line 192 "parser.y"
                                { if (yychar == YYEOF) {
                                    parser->syntax_tree = nao;
                                    YYACCEPT;
                                  } else {
                                    yybadtok(yychar, nil);
                                    parser->syntax_tree = nil;
                                  } }
#line 2871 "y.tab.c"
    break;

  case 10:
#line 199 "parser.y"
                                { parser->syntax_tree = nil;
                                  if (parser->errors >= 8)
                                    YYABORT;
                                  yyerrok;
                                  yybadtok(yychar, nil); }
#line 2881 "y.tab.c"
    break;

  case 11:
#line 208 "parser.y"
                                                { parser->ignore = 1; }
#line 2887 "y.tab.c"
    break;

  case 12:
#line 209 "parser.y"
                                                { parser->ignore = 0;
                                                  (yyval.val) = nao; }
#line 2894 "y.tab.c"
    break;

  case 13:
#line 211 "parser.y"
                                                { parser->ignore = 1; }
#line 2900 "y.tab.c"
    break;

  case 14:
#line 212 "parser.y"
                                                { parser->ignore = 0;
                                                  (yyval.val) = nao; }
#line 2907 "y.tab.c"
    break;

  case 15:
#line 214 "parser.y"
                                                { parser->ignore = 1; }
#line 2913 "y.tab.c"
    break;

  case 16:
#line 215 "parser.y"
                                                { parser->ignore = 0;
                                                  (yyval.val) = nao; }
#line 2920 "y.tab.c"
    break;

  case 17:
#line 217 "parser.y"
                                                { (yyval.val) = (yyvsp[0].val); }
#line 2926 "y.tab.c"
    break;

  case 18:
#line 218 "parser.y"
                                                { (yyval.val) = uref_helper(parser, (yyvsp[0].val)); }
#line 2932 "y.tab.c"
    break;

  case 19:
#line 219 "parser.y"
                                                { (yyval.val) = uoref_helper(parser, (yyvsp[0].val)); }
#line 2938 "y.tab.c"
    break;

  case 20:
#line 222 "parser.y"
                                                { parser->ignore = 1; }
#line 2944 "y.tab.c"
    break;

  case 21:
#line 223 "parser.y"
                                                { parser->ignore = 0;
                                                  (yyval.val) = nao; }
#line 2951 "y.tab.c"
    break;

  case 22:
#line 225 "parser.y"
                                                { parser->ignore = 1; }
#line 2957 "y.tab.c"
    break;

  case 23:
#line 226 "parser.y"
                                                { parser->ignore = 0;
                                                  (yyval.val) = nao; }
#line 2964 "y.tab.c"
    break;

  case 24:
#line 228 "parser.y"
                                                { parser->ignore = 1; }
#line 2970 "y.tab.c"
    break;

  case 25:
#line 229 "parser.y"
                                                { parser->ignore = 0;
                                                  (yyval.val) = nao; }
#line 2977 "y.tab.c"
    break;

  case 26:
#line 231 "parser.y"
                                                { (yyval.val) = (yyvsp[0].val); }
#line 2983 "y.tab.c"
    break;

  case 27:
#line 232 "parser.y"
                                                { (yyval.val) = uref_helper(parser, (yyvsp[0].val)); }
#line 2989 "y.tab.c"
    break;

  case 28:
#line 233 "parser.y"
                                                { (yyval.val) = uoref_helper(parser, (yyvsp[0].val)); }
#line 2995 "y.tab.c"
    break;

  case 29:
#line 238 "parser.y"
                    { internal_error("notreached"); }
#line 3001 "y.tab.c"
    break;

  case 30:
#line 239 "parser.y"
                       { internal_error("notreached"); }
#line 3007 "y.tab.c"
    break;

  case 31:
#line 240 "parser.y"
             { internal_error("notreached"); }
#line 3013 "y.tab.c"
    break;

  case 32:
#line 243 "parser.y"
                                        { (yyval.val) = check_parse_time_action(cons((yyvsp[0].val), nil)); }
#line 3019 "y.tab.c"
    break;

  case 33:
#line 244 "parser.y"
                                        { (yyval.val) = check_parse_time_action(cons((yyvsp[0].val), (yyvsp[-1].val)));  }
#line 3025 "y.tab.c"
    break;

  case 34:
#line 247 "parser.y"
                                { (yyval.val) = us_nreverse((yyvsp[0].val)); }
#line 3031 "y.tab.c"
    break;

  case 35:
#line 248 "parser.y"
                                { (yyval.val) = nil; }
#line 3037 "y.tab.c"
    break;

  case 36:
#line 251 "parser.y"
                                { (yyval.val) = cons((yyvsp[0].val), nil); rlc((yyval.val), (yyvsp[0].val)); }
#line 3043 "y.tab.c"
    break;

  case 37:
#line 252 "parser.y"
                                { (yyval.val) = cons((yyvsp[0].val), nil); rlc((yyval.val), (yyvsp[0].val)); }
#line 3049 "y.tab.c"
    break;

  case 38:
#line 253 "parser.y"
                                { (yyval.val) = cons((yyvsp[0].val), nil); rlc((yyval.val), (yyvsp[0].val)); }
#line 3055 "y.tab.c"
    break;

  case 39:
#line 254 "parser.y"
                                { (yyval.val) = cons((yyvsp[0].val), nil); rlc((yyval.val), (yyvsp[0].val)); }
#line 3061 "y.tab.c"
    break;

  case 40:
#line 255 "parser.y"
                                { (yyval.val) = cons((yyvsp[0].val), nil); rlc((yyval.val), (yyvsp[0].val)); }
#line 3067 "y.tab.c"
    break;

  case 41:
#line 256 "parser.y"
                                { (yyval.val) = cons((yyvsp[0].val), nil); rlc((yyval.val), (yyvsp[0].val)); }
#line 3073 "y.tab.c"
    break;

  case 42:
#line 257 "parser.y"
                                { (yyval.val) = cons((yyvsp[0].val), nil); rlc((yyval.val), (yyvsp[0].val)); }
#line 3079 "y.tab.c"
    break;

  case 43:
#line 258 "parser.y"
                                { (yyval.val) = cons((yyvsp[0].val), nil); rlc((yyval.val), (yyvsp[0].val)); }
#line 3085 "y.tab.c"
    break;

  case 44:
#line 259 "parser.y"
                                { (yyval.val) = cons((yyvsp[0].val), nil); rlc((yyval.val), (yyvsp[0].val)); }
#line 3091 "y.tab.c"
    break;

  case 45:
#line 260 "parser.y"
                                { (yyval.val) = list(define_transform(parser, (yyvsp[0].val)), nao);
                                  rlc(car((yyval.val)), (yyvsp[0].val));
                                  rlc((yyval.val), (yyvsp[0].val)); }
#line 3099 "y.tab.c"
    break;

  case 46:
#line 263 "parser.y"
                                { (yyval.val) = cons((yyvsp[0].val), nil); rlc((yyval.val), (yyvsp[0].val)); }
#line 3105 "y.tab.c"
    break;

  case 47:
#line 264 "parser.y"
                                { (yyval.val) = cons((yyvsp[0].val), nil); rlc((yyval.val), (yyvsp[0].val)); }
#line 3111 "y.tab.c"
    break;

  case 48:
#line 265 "parser.y"
                                { (yyval.val) = cons((yyvsp[0].val), nil); rlc((yyval.val), (yyvsp[0].val)); }
#line 3117 "y.tab.c"
    break;

  case 49:
#line 266 "parser.y"
                                { (yyval.val) = (yyvsp[0].val); }
#line 3123 "y.tab.c"
    break;

  case 50:
#line 269 "parser.y"
                                        { (yyval.val) = list(all_s, (yyvsp[0].val), nao);
                                          rl((yyval.val), num((yyvsp[-2].lineno))); }
#line 3130 "y.tab.c"
    break;

  case 51:
#line 271 "parser.y"
                                        { (yyval.val) = nil;
                                          yybadtok(yychar, lit("all clause")); }
#line 3137 "y.tab.c"
    break;

  case 52:
#line 276 "parser.y"
                                        { (yyval.val) = list(some_s, (yyvsp[0].val), (yyvsp[-3].val), nao);
                                          rl((yyval.val), num((yyvsp[-4].lineno))); }
#line 3144 "y.tab.c"
    break;

  case 53:
#line 280 "parser.y"
                                        { (yyval.val) = nil;
                                          yybadtok(yychar, lit("some clause")); }
#line 3151 "y.tab.c"
    break;

  case 54:
#line 284 "parser.y"
                                        { (yyval.val) = list(none_s, (yyvsp[0].val), nao);
                                          rl((yyval.val), num((yyvsp[-2].lineno))); }
#line 3158 "y.tab.c"
    break;

  case 55:
#line 286 "parser.y"
                                        { (yyval.val) = nil;
                                          yybadtok(yychar, lit("none clause")); }
#line 3165 "y.tab.c"
    break;

  case 56:
#line 290 "parser.y"
                                        { (yyval.val) = list(maybe_s, (yyvsp[0].val), nao);
                                          rl((yyval.val), num((yyvsp[-2].lineno))); }
#line 3172 "y.tab.c"
    break;

  case 57:
#line 292 "parser.y"
                                        { (yyval.val) = nil;
                                          yybadtok(yychar, lit("maybe clause")); }
#line 3179 "y.tab.c"
    break;

  case 58:
#line 296 "parser.y"
                                        { (yyval.val) = list(cases_s, (yyvsp[0].val), nao);
                                          rl((yyval.val), num((yyvsp[-2].lineno))); }
#line 3186 "y.tab.c"
    break;

  case 59:
#line 298 "parser.y"
                                        { (yyval.val) = nil;
                                          yybadtok(yychar, lit("cases clause")); }
#line 3193 "y.tab.c"
    break;

  case 60:
#line 304 "parser.y"
                                        { val name = first((yyvsp[-5].val));
                                          if (gt(length((yyvsp[-5].val)), one))
                                            yyerr("block: takes zero or no arguments");
                                          if (name && !bindable(name))
                                            yyerrorf(scnr,
                                                     lit("block: ~s is not a bindable symbol"),
                                                     name, nao);
                                          (yyval.val) = list(block_s, name, (yyvsp[-2].val), nao);
                                          rl((yyval.val), num((yyvsp[-6].lineno))); }
#line 3207 "y.tab.c"
    break;

  case 61:
#line 314 "parser.y"
                                        { (yyval.val) = nil;
                                          yybadtok(yychar, lit("block clause")); }
#line 3214 "y.tab.c"
    break;

  case 62:
#line 319 "parser.y"
                                        { (yyval.val) = list(choose_s, (yyvsp[0].val), (yyvsp[-3].val), nao);
                                          rl((yyval.val), num((yyvsp[-4].lineno))); }
#line 3221 "y.tab.c"
    break;

  case 63:
#line 322 "parser.y"
                                        { (yyval.val) = nil;
                                          yybadtok(yychar, lit("choose clause")); }
#line 3228 "y.tab.c"
    break;

  case 64:
#line 328 "parser.y"
                                        { val args = match_expand_keyword_args((yyvsp[-5].val));
                                          (yyval.val) = list(gather_s,
                                                    append2(mapcar(curry_12_1(func_n2(cons), nil),
                                                                   first((yyvsp[-2].val))), rest((yyvsp[-2].val))),
                                                    args, nao);
                                          rl((yyval.val), num((yyvsp[-6].lineno))); }
#line 3239 "y.tab.c"
    break;

  case 65:
#line 339 "parser.y"
                                        { val args = match_expand_keyword_args((yyvsp[-10].val));
                                          (yyval.val) = list(gather_s,
                                                    append2(mapcar(curry_12_1(func_n2(cons), nil),
                                                                   first((yyvsp[-7].val))), rest((yyvsp[-7].val))),
                                                    args, cons(cdr((yyvsp[-6].val)),
                                                             cons((yyvsp[-5].val), (yyvsp[-2].val))), nao);
                                          rl((yyval.val), num((yyvsp[-11].lineno))); }
#line 3251 "y.tab.c"
    break;

  case 66:
#line 348 "parser.y"
                                        { (yyval.val) = nil;
                                          yybadtok(yychar, lit("gather clause")); }
#line 3258 "y.tab.c"
    break;

  case 67:
#line 353 "parser.y"
                                        { (yyval.val) = if2((yyvsp[-1].val), cons((yyvsp[-1].val), (yyvsp[0].val))); }
#line 3264 "y.tab.c"
    break;

  case 68:
#line 356 "parser.y"
                                                { (yyval.val) = (yyvsp[0].val); }
#line 3270 "y.tab.c"
    break;

  case 69:
#line 357 "parser.y"
                                                { (yyval.val) = (yyvsp[0].val); }
#line 3276 "y.tab.c"
    break;

  case 70:
#line 358 "parser.y"
                                                { (yyval.val) = nil; }
#line 3282 "y.tab.c"
    break;

  case 71:
#line 362 "parser.y"
                                          { val args = match_expand_keyword_args((yyvsp[-5].val));
                                            (yyval.val) = list(car((yyvsp[-6].val)),
                                                      (yyvsp[-2].val), nil, args,
                                                      nao);
                                            rl((yyval.val), cdr((yyvsp[-6].val))); }
#line 3292 "y.tab.c"
    break;

  case 72:
#line 370 "parser.y"
                                          { val args = match_expand_keyword_args((yyvsp[-10].val));
                                            if (nilp((yyvsp[-2].val)))
                                              yyerr("empty until/last in collect");
                                            (yyval.val) = list(car((yyvsp[-11].val)), (yyvsp[-7].val),
                                                      cons(cdr((yyvsp[-6].val)),
                                                           cons((yyvsp[-5].val), (yyvsp[-2].val))),
                                                      args, nao);
                                            rl((yyval.val), cdr((yyvsp[-11].val)));
                                            rl((yyvsp[-2].val), car((yyvsp[-6].val))); }
#line 3306 "y.tab.c"
    break;

  case 73:
#line 380 "parser.y"
                                        { (yyval.val) = nil;
                                          yybadtok(yychar, lit("collect clause")); }
#line 3313 "y.tab.c"
    break;

  case 74:
#line 384 "parser.y"
                         { (yyval.val) = cons(collect_s, num((yyvsp[0].lineno))); }
#line 3319 "y.tab.c"
    break;

  case 75:
#line 385 "parser.y"
                        { (yyval.val) = cons(repeat_s, num((yyvsp[0].lineno))); }
#line 3325 "y.tab.c"
    break;

  case 76:
#line 388 "parser.y"
                   { (yyval.val) = cons(num((yyvsp[0].lineno)), until_s); }
#line 3331 "y.tab.c"
    break;

  case 77:
#line 389 "parser.y"
                   { (yyval.val) = cons(num((yyvsp[0].lineno)), last_s); }
#line 3337 "y.tab.c"
    break;

  case 78:
#line 392 "parser.y"
                                                { (yyval.val) = if2((yyvsp[-1].val), cons((yyvsp[-1].val), (yyvsp[0].val))); }
#line 3343 "y.tab.c"
    break;

  case 79:
#line 395 "parser.y"
                                                { (yyval.val) = nil; }
#line 3349 "y.tab.c"
    break;

  case 80:
#line 396 "parser.y"
                                                { (yyval.val) = (yyvsp[0].val); }
#line 3355 "y.tab.c"
    break;

  case 81:
#line 397 "parser.y"
                                                { (yyval.val) = (yyvsp[0].val); }
#line 3361 "y.tab.c"
    break;

  case 82:
#line 404 "parser.y"
                                { if (opt_compat && opt_compat <= 136)
                                  { val xexp = expand_meta((yyvsp[-7].val), nil);
                                    val req = rlc(cons(require_s, xexp), (yyvsp[-7].val));
                                    val iff = rlc(cons(cons(cons(req, nil), (yyvsp[-4].val)), nil), (yyvsp[-7].val));
                                    val elifs = (yyvsp[-3].val);
                                    val els = cons((yyvsp[-2].val), nil);
                                    val cases = nappend2(nappend2(iff, elifs), els);
                                    (yyval.val) = list(cases_s, cases, nao); }
                                  else
                                  { val expr = expand(car((yyvsp[-7].val)), nil);
                                    val ifs = (yyvsp[-4].val);
                                    val branch = cons(cons(expr, ifs), nil);
                                    val elifs = (yyvsp[-3].val);
                                    val els = (yyvsp[-2].val);
                                    if (cdr((yyvsp[-7].val)))
                                      yyerr("extra expression in if");
                                    (yyval.val) = cons(if_s,
                                              nappend2(branch, nappend2(elifs, els)));
                                    rl((yyval.val), num((yyvsp[-8].lineno))); } }
#line 3385 "y.tab.c"
    break;

  case 83:
#line 424 "parser.y"
                                { (yyval.val) = nil; yybadtok(yychar, lit("if clause")); }
#line 3391 "y.tab.c"
    break;

  case 84:
#line 429 "parser.y"
                                     { if (opt_compat && opt_compat <= 136)
                                       { val xexp = expand_meta((yyvsp[-4].val), nil);
                                         val req = rlc(cons(require_s, xexp), (yyvsp[-4].val));
                                         (yyval.val) = cons(cons(cons(req, nil), (yyvsp[-1].val)), (yyvsp[0].val)); }
                                       else
                                       { val expr = expand(car((yyvsp[-4].val)), nil);
                                         val elifs = (yyvsp[-1].val);
                                         val branch = cons(cons(expr, elifs), nil);
                                         if (cdr((yyvsp[-4].val)))
                                           yyerr("extra expression in elif");
                                         (yyval.val) = nappend2(branch, (yyvsp[0].val)); } }
#line 3407 "y.tab.c"
    break;

  case 85:
#line 440 "parser.y"
                                     { (yyval.val) = nil; }
#line 3413 "y.tab.c"
    break;

  case 86:
#line 444 "parser.y"
                                     { if (opt_compat && opt_compat <= 136)
                                       { (yyval.val) = (yyvsp[0].val); }
                                       else
                                       { (yyval.val) = cons(cons(t, (yyvsp[0].val)), nil); } }
#line 3422 "y.tab.c"
    break;

  case 87:
#line 448 "parser.y"
                                     { (yyval.val) = nil; }
#line 3428 "y.tab.c"
    break;

  case 88:
#line 451 "parser.y"
                                { (yyval.val) = (yyvsp[-1].val); }
#line 3434 "y.tab.c"
    break;

  case 89:
#line 454 "parser.y"
                                { (yyval.val) = (yyvsp[0].val); }
#line 3440 "y.tab.c"
    break;

  case 90:
#line 455 "parser.y"
                                { (yyval.val) = nil; }
#line 3446 "y.tab.c"
    break;

  case 91:
#line 458 "parser.y"
                                { (yyval.val) = cons((yyvsp[0].val), nil);
                                  rlc((yyval.val), (yyvsp[0].val)); }
#line 3453 "y.tab.c"
    break;

  case 92:
#line 460 "parser.y"
                                { (yyval.val) = cons((yyvsp[-1].val), (yyvsp[0].val));
                                  rlc((yyval.val), (yyvsp[-1].val)); }
#line 3460 "y.tab.c"
    break;

  case 93:
#line 465 "parser.y"
                                { (yyval.val) = rl(string_own((yyvsp[0].lexeme)), num(parser->lineno)); }
#line 3466 "y.tab.c"
    break;

  case 94:
#line 466 "parser.y"
                                { if ((yyvsp[0].lexeme)[0] == ' ' && (yyvsp[0].lexeme)[1] == 0)
                                  { val spaces = list(oneplus_s,
                                                      chr(' '), nao);
                                    free((yyvsp[0].lexeme));
                                    (yyval.val) = regex_compile(spaces, nil);
                                    rl((yyval.val), num(parser->lineno)); }
                                  else
                                  { (yyval.val) = rl(string_own((yyvsp[0].lexeme)), num(parser->lineno)); }}
#line 3479 "y.tab.c"
    break;

  case 95:
#line 474 "parser.y"
                                { (yyval.val) = (yyvsp[0].val);
                                  rl((yyval.val), num(parser->lineno)); }
#line 3486 "y.tab.c"
    break;

  case 96:
#line 476 "parser.y"
                                { (yyval.val) = null_string; }
#line 3492 "y.tab.c"
    break;

  case 97:
#line 479 "parser.y"
                                { (yyval.val) = rlc(cons((yyvsp[0].val), nil), (yyvsp[0].val)); }
#line 3498 "y.tab.c"
    break;

  case 98:
#line 480 "parser.y"
                                { (yyval.val) = rlc(cons((yyvsp[-1].val), (yyvsp[0].val)), (yyvsp[0].val)); }
#line 3504 "y.tab.c"
    break;

  case 99:
#line 483 "parser.y"
                                { (yyval.val) = rlc(cons(text_s, (yyvsp[0].val)), (yyvsp[0].val));
                                  (yyval.val) = rlc(optimize_text((yyval.val)), (yyval.val)); }
#line 3511 "y.tab.c"
    break;

  case 100:
#line 485 "parser.y"
                                { (yyval.val) = rl((yyvsp[0].val), num(parser->lineno));
                                  match_reg_elem((yyval.val)); }
#line 3518 "y.tab.c"
    break;

  case 101:
#line 487 "parser.y"
                                { val sym = first((yyvsp[0].val));
                                  if (sym ==  do_s || sym == require_s)
                                    (yyval.val) = rlc(cons(sym,
                                                   expand_forms(rest((yyvsp[0].val)), nil)),
                                              (yyvsp[0].val));
                                  else
                                  { (yyval.val) = match_expand_elem((yyvsp[0].val));
                                    match_reg_elem((yyval.val)); } }
#line 3531 "y.tab.c"
    break;

  case 102:
#line 495 "parser.y"
                                        { val args = match_expand_keyword_args((yyvsp[-3].val));
                                          (yyval.val) = list(coll_s, (yyvsp[-1].val), nil, args, nao);
                                          rl((yyval.val), num((yyvsp[-4].lineno))); }
#line 3539 "y.tab.c"
    break;

  case 103:
#line 500 "parser.y"
                                { val args = match_expand_keyword_args((yyvsp[-7].val));
                                  (yyval.val) = list(coll_s, (yyvsp[-5].val), cons(cdr((yyvsp[-4].val)),
                                                             cons((yyvsp[-3].val), (yyvsp[-1].val))),
                                            args, nao);
                                  rl((yyval.val), num((yyvsp[-8].lineno)));
                                  rl((yyvsp[-3].val), car((yyvsp[-4].val))); }
#line 3550 "y.tab.c"
    break;

  case 104:
#line 506 "parser.y"
                                       { val args = match_expand_keyword_args((yyvsp[-3].val));
                                         (yyval.val) = list(rep_s, (yyvsp[-1].val), nil, args, nao);
                                         rl((yyval.val), num((yyvsp[-4].lineno))); }
#line 3558 "y.tab.c"
    break;

  case 105:
#line 512 "parser.y"
                                { val args = match_expand_keyword_args((yyvsp[-7].val));
                                  (yyval.val) = list(rep_s, (yyvsp[-5].val), cons(cdr((yyvsp[-4].val)),
                                                            cons((yyvsp[-3].val), (yyvsp[-1].val))),
                                            args, nao);
                                  rl((yyval.val), num((yyvsp[-8].lineno)));
                                  rl((yyvsp[-3].val), car((yyvsp[-4].val))); }
#line 3569 "y.tab.c"
    break;

  case 106:
#line 518 "parser.y"
                                     { (yyval.val) = list(block_s, car((yyvsp[-3].val)),
                                                 cons((yyvsp[-1].val), nil), nao);
                                       rl((yyval.val), num((yyvsp[-4].lineno))); }
#line 3577 "y.tab.c"
    break;

  case 107:
#line 521 "parser.y"
                                { (yyval.val) = nil;
                                  yybadtok(yychar, lit("coll clause")); }
#line 3584 "y.tab.c"
    break;

  case 108:
#line 523 "parser.y"
                               { (yyval.val) = nil;
                                 yybadtok(yychar, lit("rep clause")); }
#line 3591 "y.tab.c"
    break;

  case 109:
#line 525 "parser.y"
                               { (yyval.val) = nil;
                                 yybadtok(yychar, lit("rep clause")); }
#line 3598 "y.tab.c"
    break;

  case 110:
#line 527 "parser.y"
                                { (yyval.val) = rl(list(all_s, t, (yyvsp[0].val), nao), num((yyvsp[-1].lineno))); }
#line 3604 "y.tab.c"
    break;

  case 111:
#line 529 "parser.y"
                                { (yyval.val) = rl(list(some_s, t, (yyvsp[0].val), (yyvsp[-2].val), nao), num((yyvsp[-3].lineno))); }
#line 3610 "y.tab.c"
    break;

  case 112:
#line 530 "parser.y"
                                { (yyval.val) = rl(list(none_s, t, (yyvsp[0].val), nao), num((yyvsp[-1].lineno))); }
#line 3616 "y.tab.c"
    break;

  case 113:
#line 531 "parser.y"
                                { (yyval.val) = rl(list(maybe_s, t, (yyvsp[0].val), nao), num((yyvsp[-1].lineno))); }
#line 3622 "y.tab.c"
    break;

  case 114:
#line 532 "parser.y"
                                { (yyval.val) = rl(list(cases_s, t, (yyvsp[0].val), nao), num((yyvsp[-1].lineno))); }
#line 3628 "y.tab.c"
    break;

  case 115:
#line 534 "parser.y"
                                { (yyval.val) = list(choose_s, t, (yyvsp[0].val), (yyvsp[-2].val), nao);
                                  rl((yyval.val), num((yyvsp[-3].lineno))); }
#line 3635 "y.tab.c"
    break;

  case 116:
#line 537 "parser.y"
                                { (yyval.val) = list(define_s, t, (yyvsp[-1].val), (yyvsp[-3].val), nao);
                                  rl((yyval.val), num((yyvsp[-4].lineno)));
                                  match_reg_params(second((yyvsp[-3].val))); }
#line 3643 "y.tab.c"
    break;

  case 117:
#line 542 "parser.y"
                                                { (yyval.val) = if2((yyvsp[-1].val), cons((yyvsp[-1].val), (yyvsp[0].val))); }
#line 3649 "y.tab.c"
    break;

  case 118:
#line 545 "parser.y"
                                                { (yyval.val) = nil; }
#line 3655 "y.tab.c"
    break;

  case 119:
#line 546 "parser.y"
                                                { (yyval.val) = (yyvsp[0].val); }
#line 3661 "y.tab.c"
    break;

  case 120:
#line 547 "parser.y"
                                                { (yyval.val) = (yyvsp[0].val); }
#line 3667 "y.tab.c"
    break;

  case 121:
#line 552 "parser.y"
                                { (yyval.val) = list(define_s, (yyvsp[-5].val), (yyvsp[-2].val), nao);
                                  rl((yyval.val), num((yyvsp[-6].lineno)));
                                  match_reg_params(second((yyvsp[-5].val))); }
#line 3675 "y.tab.c"
    break;

  case 122:
#line 557 "parser.y"
                                { (yyval.val) = list(define_s, nil, (yyvsp[-2].val), nao);
                                  rl((yyval.val), num((yyvsp[-5].lineno))); }
#line 3682 "y.tab.c"
    break;

  case 123:
#line 559 "parser.y"
                                { (yyval.val) = nil;
                                  yybadtok(yychar, lit("define directive")); }
#line 3689 "y.tab.c"
    break;

  case 124:
#line 562 "parser.y"
                                { (yyval.val) = nil; yybadtok(yychar, lit("define")); }
#line 3695 "y.tab.c"
    break;

  case 125:
#line 564 "parser.y"
                                { (yyval.val) = nil;
                                  yybadtok(yychar, lit("define")); }
#line 3702 "y.tab.c"
    break;

  case 126:
#line 571 "parser.y"
                                { (yyval.val) = list(try_s,
                                            flatten(mapcar(func_n1(second),
                                                           (yyvsp[-2].val))),
                                            (yyvsp[-3].val), (yyvsp[-2].val), nao);
                                  rl((yyval.val), num((yyvsp[-5].lineno))); }
#line 3712 "y.tab.c"
    break;

  case 127:
#line 577 "parser.y"
                                { (yyval.val) = nil;
                                  yybadtok(yychar, lit("try clause")); }
#line 3719 "y.tab.c"
    break;

  case 128:
#line 583 "parser.y"
                                        { (yyval.val) = cons(list(catch_s, cons(t, nil),
                                                         (yyvsp[-1].val), nao), (yyvsp[0].val));
                                          rl((yyval.val), num((yyvsp[-4].lineno))); }
#line 3727 "y.tab.c"
    break;

  case 129:
#line 588 "parser.y"
                                        { (yyval.val) = cons(list(catch_s, (yyvsp[-4].val), (yyvsp[-1].val), nao),
                                                    (yyvsp[0].val));
                                          process_catch_exprs((yyvsp[-4].val));
                                          rl((yyval.val), num((yyvsp[-5].lineno))); }
#line 3736 "y.tab.c"
    break;

  case 130:
#line 593 "parser.y"
                                        { (yyval.val) = cons(list(finally_s, nil,
                                                         (yyvsp[0].val), nao),
                                                    nil);
                                          rl((yyval.val), num((yyvsp[-2].lineno))); }
#line 3745 "y.tab.c"
    break;

  case 131:
#line 597 "parser.y"
                                        { (yyval.val) = nil; }
#line 3751 "y.tab.c"
    break;

  case 132:
#line 599 "parser.y"
                                        { (yyval.val) = nil;
                                          yybadtok(yychar, lit("catch clause")); }
#line 3758 "y.tab.c"
    break;

  case 133:
#line 602 "parser.y"
                                        { (yyval.val) = nil;
                                          yybadtok(yychar, lit("catch clause")); }
#line 3765 "y.tab.c"
    break;

  case 134:
#line 605 "parser.y"
                                        { (yyval.val) = nil;
                                          yybadtok(yychar, lit("finally clause")); }
#line 3772 "y.tab.c"
    break;

  case 135:
#line 612 "parser.y"
                                { (yyval.val) = nil;
                                  yyerr("obsolete output syntax: trailing material"); }
#line 3779 "y.tab.c"
    break;

  case 136:
#line 615 "parser.y"
                                { (yyval.val) = rl(list(output_s, nao), num((yyvsp[-4].lineno))); }
#line 3785 "y.tab.c"
    break;

  case 137:
#line 618 "parser.y"
                                { (yyval.val) = rl(list(output_s, (yyvsp[-2].val), nao), num((yyvsp[-5].lineno))); }
#line 3791 "y.tab.c"
    break;

  case 138:
#line 621 "parser.y"
                                { cons_bind (dest, rest, (yyvsp[-5].val));
                                  val dest_ex = expand_form_ver(dest, 166);
                                  val args = if3(dest_ex == dest,
                                                 (yyvsp[-5].val), cons(dest_ex, rest));
                                  (yyval.val) = list(output_s, (yyvsp[-2].val), args, nao);
                                  rl((yyval.val), num((yyvsp[-6].lineno)));
                                  { val into_var = second(memql(into_k, args));
                                    val named_var = second(memql(named_k, args));
                                    match_reg_var(into_var);
                                    match_reg_var(named_var); } }
#line 3806 "y.tab.c"
    break;

  case 139:
#line 633 "parser.y"
                                { (yyval.val) = nil;
                                  yyerr("invalid combination of old and "
                                               "new syntax in output directive"); }
#line 3814 "y.tab.c"
    break;

  case 140:
#line 636 "parser.y"
                                { (yyval.val) = nil;
                                  yybadtok(yychar, lit("output directive")); }
#line 3821 "y.tab.c"
    break;

  case 141:
#line 639 "parser.y"
                                { (yyval.val) = nil;
                                  yybadtok(yychar, lit("output clause")); }
#line 3828 "y.tab.c"
    break;

  case 142:
#line 642 "parser.y"
                                { (yyval.val) = nil;
                                  yybadtok(yychar, lit("output clause")); }
#line 3835 "y.tab.c"
    break;

  case 143:
#line 645 "parser.y"
                                { (yyval.val) = nil;
                                  yybadtok(yychar, lit("output clause")); }
#line 3842 "y.tab.c"
    break;

  case 144:
#line 648 "parser.y"
                                { (yyval.val) = nil;
                                  yybadtok(yychar, lit("output clause")); }
#line 3849 "y.tab.c"
    break;

  case 145:
#line 652 "parser.y"
                                        { (yyval.val) = cons((yyvsp[0].val), nil); }
#line 3855 "y.tab.c"
    break;

  case 146:
#line 653 "parser.y"
                                        { (yyval.val) = cons((yyvsp[-1].val), (yyvsp[0].val));  }
#line 3861 "y.tab.c"
    break;

  case 147:
#line 656 "parser.y"
                                        { (yyval.val) = cons((yyvsp[0].val), nil); }
#line 3867 "y.tab.c"
    break;

  case 148:
#line 657 "parser.y"
                                        { (yyval.val) = (yyvsp[0].val); }
#line 3873 "y.tab.c"
    break;

  case 149:
#line 663 "parser.y"
                                        { (yyval.val) = repeat_rep_helper(repeat_s,
                                                                 (yyvsp[-6].val), (yyvsp[-3].val), (yyvsp[-2].val));
                                          rl((yyval.val), num((yyvsp[-7].lineno))); }
#line 3881 "y.tab.c"
    break;

  case 150:
#line 667 "parser.y"
                                { (yyval.val) = nil;
                                  yybadtok(yychar, lit("repeat clause")); }
#line 3888 "y.tab.c"
    break;

  case 151:
#line 673 "parser.y"
                                        { (yyval.val) = cons(cons(single_s, (yyvsp[-1].val)), (yyvsp[0].val));
                                          rl((yyval.val), num((yyvsp[-3].lineno))); }
#line 3895 "y.tab.c"
    break;

  case 152:
#line 677 "parser.y"
                                        { (yyval.val) = cons(cons(first_s, (yyvsp[-1].val)), (yyvsp[0].val));
                                          rl((yyval.val), num((yyvsp[-3].lineno))); }
#line 3902 "y.tab.c"
    break;

  case 153:
#line 681 "parser.y"
                                        { if ((yyvsp[-4].val))
                                            yyerrorf(scnr,
                                                     lit("last: in output, "
                                                         "takes no arguments"),
                                                     nao);
                                          (yyval.val) = cons(cons(last_s, (yyvsp[-1].val)), (yyvsp[0].val));
                                          rl((yyval.val), num((yyvsp[-5].lineno))); }
#line 3914 "y.tab.c"
    break;

  case 154:
#line 690 "parser.y"
                                        { (yyval.val) = cons(cons(empty_s, (yyvsp[-1].val)), (yyvsp[0].val));
                                          rl((yyval.val), num((yyvsp[-3].lineno))); }
#line 3921 "y.tab.c"
    break;

  case 155:
#line 695 "parser.y"
                                        { (yyval.val) = cons(cons(mod_s,
                                                         cons(expand_forms_ver((yyvsp[-4].val), 166),
                                                              (yyvsp[-1].val))), (yyvsp[0].val));
                                          rl((yyval.val), num((yyvsp[-5].lineno))); }
#line 3930 "y.tab.c"
    break;

  case 156:
#line 702 "parser.y"
                                        { (yyval.val) = cons(cons(modlast_s,
                                                         cons(expand_forms_ver((yyvsp[-4].val), 166),
                                                              (yyvsp[-1].val))), (yyvsp[0].val));
                                          rl((yyval.val), num((yyvsp[-5].lineno))); }
#line 3939 "y.tab.c"
    break;

  case 157:
#line 706 "parser.y"
                                        { (yyval.val) = nil; }
#line 3945 "y.tab.c"
    break;

  case 158:
#line 710 "parser.y"
                                { (yyval.val) = (yyvsp[0].val); }
#line 3951 "y.tab.c"
    break;

  case 159:
#line 711 "parser.y"
                                { (yyval.val) = nil; }
#line 3957 "y.tab.c"
    break;

  case 160:
#line 713 "parser.y"
                                { (yyval.val) = (yyvsp[-1].val); }
#line 3963 "y.tab.c"
    break;

  case 161:
#line 716 "parser.y"
                                { (yyval.val) = (yyvsp[0].val);
                                  rl((yyval.val), num(parser->lineno)); }
#line 3970 "y.tab.c"
    break;

  case 162:
#line 718 "parser.y"
                                { (yyval.val) = nil; }
#line 3976 "y.tab.c"
    break;

  case 163:
#line 721 "parser.y"
                                { (yyval.val) = cons((yyvsp[0].val), nil); }
#line 3982 "y.tab.c"
    break;

  case 164:
#line 722 "parser.y"
                                { (yyval.val) = cons((yyvsp[-1].val), (yyvsp[0].val)); }
#line 3988 "y.tab.c"
    break;

  case 165:
#line 723 "parser.y"
                                { (yyval.val) = cons((yyvsp[0].val), nil); }
#line 3994 "y.tab.c"
    break;

  case 166:
#line 724 "parser.y"
                                { (yyval.val) = cons((yyvsp[-1].val), (yyvsp[0].val)); }
#line 4000 "y.tab.c"
    break;

  case 167:
#line 727 "parser.y"
                                { (yyval.val) = string_own((yyvsp[0].lexeme));
                                  rl((yyval.val), num(parser->lineno)); }
#line 4007 "y.tab.c"
    break;

  case 168:
#line 729 "parser.y"
                                { (yyval.val) = string_own((yyvsp[0].lexeme));
                                  rl((yyval.val), num(parser->lineno)); }
#line 4014 "y.tab.c"
    break;

  case 169:
#line 731 "parser.y"
                                { (yyval.val) = (yyvsp[0].val); }
#line 4020 "y.tab.c"
    break;

  case 170:
#line 732 "parser.y"
                                { (yyval.val) = rlc(list(expr_s,
                                                 expand((yyvsp[0].val), nil), nao), (yyvsp[0].val)); }
#line 4027 "y.tab.c"
    break;

  case 171:
#line 734 "parser.y"
                                { (yyval.val) = (yyvsp[0].val); }
#line 4033 "y.tab.c"
    break;

  case 172:
#line 738 "parser.y"
                                { (yyval.val) = repeat_rep_helper(rep_s, (yyvsp[-4].val), (yyvsp[-2].val), (yyvsp[-1].val));
                                  rl((yyval.val), num((yyvsp[-5].lineno))); }
#line 4040 "y.tab.c"
    break;

  case 173:
#line 740 "parser.y"
                                { (yyval.val) = nil;
                                  yybadtok(yychar, lit("rep clause")); }
#line 4047 "y.tab.c"
    break;

  case 174:
#line 745 "parser.y"
                                        { (yyval.val) = cons(cons(single_s, (yyvsp[-1].val)), (yyvsp[0].val));
                                          rl((yyval.val), num((yyvsp[-2].lineno))); }
#line 4054 "y.tab.c"
    break;

  case 175:
#line 748 "parser.y"
                                        { (yyval.val) = cons(cons(first_s, (yyvsp[-1].val)), (yyvsp[0].val));
                                          rl((yyval.val), num((yyvsp[-2].lineno))); }
#line 4061 "y.tab.c"
    break;

  case 176:
#line 751 "parser.y"
                                          { if ((yyvsp[-3].val))
                                            yyerrorf(scnr,
                                                     lit("last: in output, "
                                                         "takes no arguments"),
                                                     nao);
                                          (yyval.val) = cons(cons(last_s, (yyvsp[-1].val)), (yyvsp[0].val));
                                          rl((yyval.val), num((yyvsp[-4].lineno))); }
#line 4073 "y.tab.c"
    break;

  case 177:
#line 759 "parser.y"
                                        { (yyval.val) = cons(cons(empty_s, (yyvsp[-1].val)), (yyvsp[0].val));
                                          rl((yyval.val), num((yyvsp[-2].lineno))); }
#line 4080 "y.tab.c"
    break;

  case 178:
#line 763 "parser.y"
                                        { (yyval.val) = cons(cons(mod_s,
                                                         cons(expand_forms_ver((yyvsp[-3].val), 166),
                                                              (yyvsp[-1].val))), (yyvsp[0].val));
                                          rl((yyval.val), num((yyvsp[-4].lineno))); }
#line 4089 "y.tab.c"
    break;

  case 179:
#line 769 "parser.y"
                                        { (yyval.val) = cons(cons(modlast_s,
                                                         cons(expand_forms_ver((yyvsp[-3].val), 166),
                                                              (yyvsp[-1].val))), (yyvsp[0].val));
                                          rl((yyval.val), num((yyvsp[-4].lineno))); }
#line 4098 "y.tab.c"
    break;

  case 180:
#line 773 "parser.y"
                                        { (yyval.val) = nil; }
#line 4104 "y.tab.c"
    break;

  case 181:
#line 780 "parser.y"
                                { (yyval.val) = list(var_s, symhlpr((yyvsp[0].lexeme), nil), nao); }
#line 4110 "y.tab.c"
    break;

  case 182:
#line 781 "parser.y"
                                { (yyval.val) = list(var_s, symhlpr((yyvsp[-1].lexeme), nil), nao); }
#line 4116 "y.tab.c"
    break;

  case 183:
#line 782 "parser.y"
                                { (yyval.val) = list(var_s, symhlpr((yyvsp[-2].lexeme), nil), (yyvsp[-1].val), nao); }
#line 4122 "y.tab.c"
    break;

  case 184:
#line 783 "parser.y"
                                { (yyval.val) = list(var_s, symhlpr((yyvsp[0].lexeme), nil), (yyvsp[-1].val), nao); }
#line 4128 "y.tab.c"
    break;

  case 185:
#line 784 "parser.y"
                                { (yyval.val) = list(var_s, symhlpr((yyvsp[-1].lexeme), nil), (yyvsp[-3].val), nao); }
#line 4134 "y.tab.c"
    break;

  case 186:
#line 785 "parser.y"
                                        { (yyval.val) = nil;
                                          yyerr("longest match "
                                                "not useable with regex"); }
#line 4142 "y.tab.c"
    break;

  case 187:
#line 788 "parser.y"
                                        { (yyval.val) = nil;
                                          yyerr("longest match "
                                                "not useable with "
                                                "fixed width match"); }
#line 4151 "y.tab.c"
    break;

  case 188:
#line 792 "parser.y"
                                { (yyval.val) = nil;
                                  yybadtok(yychar, lit("variable spec")); }
#line 4158 "y.tab.c"
    break;

  case 189:
#line 794 "parser.y"
                                { (yyval.val) = nil;
                                  yybadtok(yychar, lit("variable spec")); }
#line 4165 "y.tab.c"
    break;

  case 190:
#line 798 "parser.y"
                                { (yyval.val) = list(t, nao); }
#line 4171 "y.tab.c"
    break;

  case 191:
#line 801 "parser.y"
                                { (yyval.val) = cons((yyvsp[0].val), nil); }
#line 4177 "y.tab.c"
    break;

  case 192:
#line 802 "parser.y"
                                { (yyval.val) = cons((yyvsp[0].val), nil);
                                  rlc((yyval.val), (yyvsp[0].val)); }
#line 4184 "y.tab.c"
    break;

  case 193:
#line 804 "parser.y"
                                { (yyval.val) = rlc(cons(expand_meta((yyvsp[0].val), nil),
                                                 nil), (yyvsp[0].val)); }
#line 4191 "y.tab.c"
    break;

  case 194:
#line 806 "parser.y"
                                { (yyval.val) = cons(symhlpr((yyvsp[0].lexeme), nil), nil); }
#line 4197 "y.tab.c"
    break;

  case 195:
#line 809 "parser.y"
                                { val expr = symhlpr((yyvsp[0].lexeme), nil);
                                  if (!opt_compat || opt_compat > 128)
                                    expr = expand(expr, nil);
                                  (yyval.val) = list(var_s, expr, nao);
                                  rl((yyval.val), num(parser->lineno)); }
#line 4207 "y.tab.c"
    break;

  case 196:
#line 815 "parser.y"
                                { if (opt_compat && opt_compat <= 128)
                                  { (yyval.val) = list(var_s,
                                              expand_meta((yyvsp[-2].val), nil),
                                              expand_meta((yyvsp[-1].val), nil), nao); }
                                  else
                                  { val quasi_var = list(var_s, (yyvsp[-2].val), (yyvsp[-1].val), nao);
                                    val quasi_items = cons(quasi_var, nil);
                                    (yyval.val) = car(expand_quasi(quasi_items, nil)); } }
#line 4220 "y.tab.c"
    break;

  case 197:
#line 823 "parser.y"
                                { (yyval.val) = nil;
                                  yybadtok(yychar, lit("variable spec")); }
#line 4227 "y.tab.c"
    break;

  case 198:
#line 828 "parser.y"
                                { (yyval.val) = list(var_s, (yyvsp[-2].val), (yyvsp[-1].val), nao);
                                  rl((yyval.val), num(parser->lineno)); }
#line 4234 "y.tab.c"
    break;

  case 199:
#line 830 "parser.y"
                                { (yyval.val) = nil;
                                  yybadtok(yychar, lit("variable spec")); }
#line 4241 "y.tab.c"
    break;

  case 200:
#line 835 "parser.y"
                                { if (parser->quasi_level > 0 && unquotes_occur((yyvsp[0].val), 0))
                                    (yyval.val) = rlc(cons(vector_lit_s,
                                                   cons((yyvsp[0].val), nil)), (yyvsp[0].val));
                                  else
                                    (yyval.val) = rlc(vec_list((yyvsp[0].val)), (yyvsp[0].val)); }
#line 4251 "y.tab.c"
    break;

  case 201:
#line 840 "parser.y"
                                { (yyval.val) = nil;
                                  yybadtok(yychar, lit("unassigned/reserved # notation")); }
#line 4258 "y.tab.c"
    break;

  case 202:
#line 844 "parser.y"
                                { if (parser->quasi_level > 0 && unquotes_occur((yyvsp[0].val), 0))
                                    (yyval.val) = rl(cons(hash_lit_s, (yyvsp[0].val)), num((yyvsp[-1].lineno)));
                                  else
                                    (yyval.val) = rl(hash_construct(first((yyvsp[0].val)),
                                                             rest((yyvsp[0].val))),
                                            num((yyvsp[-1].lineno))); }
#line 4269 "y.tab.c"
    break;

  case 203:
#line 850 "parser.y"
                                 { (yyval.val) = nil;
                                    yybadtok(yychar, lit("hash literal")); }
#line 4276 "y.tab.c"
    break;

  case 204:
#line 854 "parser.y"
                                { if (parser->quasi_level > 0 && unquotes_occur((yyvsp[0].val), 0))
                                    (yyval.val) = rl(cons(struct_lit_s, (yyvsp[0].val)),
                                              num((yyvsp[-1].lineno)));
                                  else
                                  { val strct = make_struct_lit(first((yyvsp[0].val)),
                                                                rest((yyvsp[0].val)));
                                    (yyval.val) = rl(strct, num((yyvsp[-1].lineno))); } }
#line 4288 "y.tab.c"
    break;

  case 205:
#line 861 "parser.y"
                                { (yyval.val) = nil;
                                    yybadtok(yychar, lit("struct literal")); }
#line 4295 "y.tab.c"
    break;

  case 206:
#line 865 "parser.y"
                                { if (length((yyvsp[0].val)) != two)
                                    yyerr("range literal needs two elements");
                                  { val range = rcons(first((yyvsp[0].val)), second((yyvsp[0].val)));
                                    (yyval.val) = rl(range, num((yyvsp[-1].lineno))); } }
#line 4304 "y.tab.c"
    break;

  case 207:
#line 869 "parser.y"
                                { (yyval.val) = nil;
                                  yybadtok(yychar, lit("range literal")); }
#line 4311 "y.tab.c"
    break;

  case 208:
#line 873 "parser.y"
                                { if (gt(length((yyvsp[0].val)), three))
                                    yyerr("excess elements in tree node");
                                  { val tn = tnode(first((yyvsp[0].val)), second((yyvsp[0].val)),
                                                   third((yyvsp[0].val)));
                                    (yyval.val) = rl(tn, num((yyvsp[-1].lineno))); } }
#line 4321 "y.tab.c"
    break;

  case 209:
#line 878 "parser.y"
                                { (yyval.val) = nil;
                                  yybadtok(yychar, lit("tree node literal")); }
#line 4328 "y.tab.c"
    break;

  case 210:
#line 882 "parser.y"
                               { if (parser->quasi_level > 0 && unquotes_occur((yyvsp[0].val), 0))
                                   (yyval.val) = rl(cons(tree_lit_s, (yyvsp[0].val)), num((yyvsp[-1].lineno)));
                                 else
                                 { val opts = first((yyvsp[0].val));
                                   val key_fn_name = pop(&opts);
                                   val less_fn_name = pop(&opts);
                                   val equal_fn_name = pop(&opts);
                                   val key_fn = fname_helper(parser, key_fn_name);
                                   val less_fn = fname_helper(parser, less_fn_name);
                                   val equal_fn = fname_helper(parser, equal_fn_name);
                                   val tr = tree(rest((yyvsp[0].val)), key_fn,
                                                 less_fn, equal_fn);
                                     (yyval.val) = rl(tr, num((yyvsp[-1].lineno))); } }
#line 4346 "y.tab.c"
    break;

  case 211:
#line 895 "parser.y"
                               { (yyval.val) = nil;
                                 yybadtok(yychar, lit("tree node literal")); }
#line 4353 "y.tab.c"
    break;

  case 212:
#line 899 "parser.y"
                                { (yyval.val) = rl((yyvsp[-1].val), num((yyvsp[-2].lineno))); }
#line 4359 "y.tab.c"
    break;

  case 213:
#line 900 "parser.y"
                                { val a = car((yyvsp[-1].val));
                                  val ur = uref_helper(parser, a);
                                  if (ur == a)
                                    (yyval.val) = (yyvsp[-1].val);
                                  else
                                    (yyval.val) = rlc(cons(ur, cdr((yyvsp[-1].val))), ur); }
#line 4370 "y.tab.c"
    break;

  case 214:
#line 906 "parser.y"
                                { (yyval.val) = nil; }
#line 4376 "y.tab.c"
    break;

  case 215:
#line 907 "parser.y"
                                { (yyval.val) = (yyvsp[-1].val); }
#line 4382 "y.tab.c"
    break;

  case 216:
#line 908 "parser.y"
                                { (yyval.val) = (yyvsp[-1].val); }
#line 4388 "y.tab.c"
    break;

  case 217:
#line 909 "parser.y"
                                { (yyval.val) = nil;
                                  yybadtok(yychar, lit("expression")); }
#line 4395 "y.tab.c"
    break;

  case 218:
#line 913 "parser.y"
                                { if (consp((yyvsp[0].val)))
                                    (yyval.val) = rl(cons(expr_s, cons((yyvsp[0].val), nil)), num((yyvsp[-1].lineno)));
                                  else
                                    (yyval.val) = rl(cons(var_s, cons((yyvsp[0].val), nil)),
                                            num((yyvsp[-1].lineno))); }
#line 4405 "y.tab.c"
    break;

  case 219:
#line 918 "parser.y"
                                { (yyval.val) = nil;
                                  yybadtok(yychar, lit("meta expression")); }
#line 4412 "y.tab.c"
    break;

  case 220:
#line 922 "parser.y"
                                { val a = car((yyvsp[-1].val));
                                  val ur = uref_helper(parser, a);
                                  (yyval.val) = rlcp_tree(cons(dwim_s,
                                                      cons(ur, cdr((yyvsp[-1].val)))), ur); }
#line 4421 "y.tab.c"
    break;

  case 221:
#line 926 "parser.y"
                                { (yyval.val) = rl(cons(dwim_s, (yyvsp[-1].val)), num((yyvsp[-2].lineno))); }
#line 4427 "y.tab.c"
    break;

  case 222:
#line 927 "parser.y"
                                { (yyval.val) = rl(cons(dwim_s, nil), num((yyvsp[-1].lineno))); }
#line 4433 "y.tab.c"
    break;

  case 223:
#line 928 "parser.y"
                                { (yyval.val) = nil;
                                  yybadtok(yychar, lit("DWIM expression")); }
#line 4440 "y.tab.c"
    break;

  case 227:
#line 937 "parser.y"
                                { (yyval.val) = rlc(expand_meta((yyvsp[0].val), nil), (yyvsp[0].val)); }
#line 4446 "y.tab.c"
    break;

  case 228:
#line 940 "parser.y"
                                { (yyval.val) = (yyvsp[0].val); }
#line 4452 "y.tab.c"
    break;

  case 229:
#line 941 "parser.y"
                                { (yyval.val) = nil; }
#line 4458 "y.tab.c"
    break;

  case 230:
#line 944 "parser.y"
                                { val term_atom = pop(&(yyvsp[0].val));
                                  val tail_cons = (yyvsp[0].val);
                                  (yyval.val) = us_nreverse((yyvsp[0].val));
                                  if (term_atom != unique_s)
                                    rplacd(tail_cons, term_atom); }
#line 4468 "y.tab.c"
    break;

  case 231:
#line 951 "parser.y"
                                { val exprs = cons((yyvsp[0].val), nil);
                                  rlc(exprs, (yyvsp[0].val));
                                  (yyval.val) = rlc(cons(unique_s, exprs), exprs); }
#line 4476 "y.tab.c"
    break;

  case 232:
#line 954 "parser.y"
                                { parser->ignore = 1; }
#line 4482 "y.tab.c"
    break;

  case 233:
#line 955 "parser.y"
                                { parser->ignore = 0;
                                  (yyval.val) = cons(unique_s, nil); }
#line 4489 "y.tab.c"
    break;

  case 234:
#line 957 "parser.y"
                                { parser->ignore = 1; }
#line 4495 "y.tab.c"
    break;

  case 235:
#line 958 "parser.y"
                                { parser->ignore = 0;
                                  (yyval.val) = (yyvsp[-3].val); }
#line 4502 "y.tab.c"
    break;

  case 236:
#line 960 "parser.y"
                                { uses_or2;
                                  val term_atom_cons = (yyvsp[-1].val);
                                  val exprs = cdr((yyvsp[-1].val));
                                  misplaced_consing_dot_check(scnr, term_atom_cons);
                                  rplacd(term_atom_cons,
                                         rlc(cons((yyvsp[0].val), exprs), or2((yyvsp[0].val), exprs)));
                                  (yyval.val) = term_atom_cons; }
#line 4514 "y.tab.c"
    break;

  case 237:
#line 968 "parser.y"
                                { val term_atom_cons = (yyvsp[-2].val);
                                  misplaced_consing_dot_check(scnr, term_atom_cons);
                                  rplaca(term_atom_cons, (yyvsp[0].val));
                                  (yyval.val) = (yyvsp[-2].val); }
#line 4523 "y.tab.c"
    break;

  case 238:
#line 972 "parser.y"
                                { (yyval.val) = cons(unique_s, us_nreverse(rl((yyvsp[0].val), num((yyvsp[-1].lineno)))));
                                  rlc((yyval.val), cdr((yyval.val))); }
#line 4530 "y.tab.c"
    break;

  case 239:
#line 975 "parser.y"
                                { val term_atom_cons = (yyvsp[-2].val);
                                  val exprs = cdr((yyvsp[-2].val));
                                  misplaced_consing_dot_check(scnr, term_atom_cons);
                                  rplacd(term_atom_cons,
                                         nappend2(rl(us_nreverse((yyvsp[0].val)), num((yyvsp[-1].lineno))),
                                                  exprs));
                                  (yyval.val) = term_atom_cons; }
#line 4542 "y.tab.c"
    break;

  case 240:
#line 982 "parser.y"
                                { (yyval.val) = cons(unique_s, rl((yyvsp[0].val), num((yyvsp[-1].lineno))));
                                  rlc((yyval.val), cdr((yyval.val))); }
#line 4549 "y.tab.c"
    break;

  case 241:
#line 985 "parser.y"
                                { val term_atom_cons = (yyvsp[-2].val);
                                  val exprs = cdr((yyvsp[-2].val));
                                  misplaced_consing_dot_check(scnr, term_atom_cons);
                                  rplacd(term_atom_cons,
                                         nappend2(rl(us_nreverse((yyvsp[0].val)), num((yyvsp[-1].lineno))),
                                                  exprs));
                                  (yyval.val) = term_atom_cons; }
#line 4561 "y.tab.c"
    break;

  case 242:
#line 994 "parser.y"
                                { (yyval.val) = ifnign(symhlpr((yyvsp[0].lexeme), t)); }
#line 4567 "y.tab.c"
    break;

  case 243:
#line 995 "parser.y"
                                { (yyval.val) = cons(var_s, cons((yyvsp[0].val), nil));
                                  rl((yyval.val), num(parser->lineno)); }
#line 4574 "y.tab.c"
    break;

  case 244:
#line 997 "parser.y"
                                { (yyval.val) = (yyvsp[0].val); }
#line 4580 "y.tab.c"
    break;

  case 245:
#line 998 "parser.y"
                                { (yyval.val) = (yyvsp[0].val); }
#line 4586 "y.tab.c"
    break;

  case 246:
#line 999 "parser.y"
                                { (yyval.val) = (yyvsp[0].val); }
#line 4592 "y.tab.c"
    break;

  case 247:
#line 1000 "parser.y"
                                { (yyval.val) = (yyvsp[0].val); }
#line 4598 "y.tab.c"
    break;

  case 248:
#line 1001 "parser.y"
                                { (yyval.val) = (yyvsp[0].val); }
#line 4604 "y.tab.c"
    break;

  case 249:
#line 1002 "parser.y"
                                { (yyval.val) = (yyvsp[0].val); }
#line 4610 "y.tab.c"
    break;

  case 250:
#line 1003 "parser.y"
                                { (yyval.val) = (yyvsp[0].val); }
#line 4616 "y.tab.c"
    break;

  case 251:
#line 1004 "parser.y"
                                { (yyval.val) = (yyvsp[0].val); }
#line 4622 "y.tab.c"
    break;

  case 252:
#line 1005 "parser.y"
                                { (yyval.val) = (yyvsp[0].val); }
#line 4628 "y.tab.c"
    break;

  case 253:
#line 1006 "parser.y"
                                { (yyval.val) = (yyvsp[0].val); }
#line 4634 "y.tab.c"
    break;

  case 254:
#line 1007 "parser.y"
                                { (yyval.val) = (yyvsp[0].val); }
#line 4640 "y.tab.c"
    break;

  case 255:
#line 1008 "parser.y"
                                { (yyval.val) = (yyvsp[0].val); }
#line 4646 "y.tab.c"
    break;

  case 256:
#line 1009 "parser.y"
                                { (yyval.val) = rl((yyvsp[0].val), num((yyvsp[-1].lineno))); }
#line 4652 "y.tab.c"
    break;

  case 257:
#line 1010 "parser.y"
                                { (yyval.val) = rl(cons(quasilist_s, (yyvsp[0].val)), num((yyvsp[-1].lineno))); }
#line 4658 "y.tab.c"
    break;

  case 258:
#line 1011 "parser.y"
                                { (yyval.val) = (yyvsp[0].val); }
#line 4664 "y.tab.c"
    break;

  case 259:
#line 1012 "parser.y"
                                { (yyval.val) = rl(rlc(list(quote_s, (yyvsp[0].val), nao), (yyvsp[0].val)),
                                          num(parser->lineno)); }
#line 4671 "y.tab.c"
    break;

  case 260:
#line 1014 "parser.y"
                                { parser->quasi_level++; }
#line 4677 "y.tab.c"
    break;

  case 261:
#line 1015 "parser.y"
                                { parser->quasi_level--;
                                  (yyval.val) = rl(rlc(list(sys_qquote_s, (yyvsp[0].val), nao), (yyvsp[0].val)),
                                          num(parser->lineno)); }
#line 4685 "y.tab.c"
    break;

  case 262:
#line 1018 "parser.y"
                                { parser->quasi_level--; }
#line 4691 "y.tab.c"
    break;

  case 263:
#line 1019 "parser.y"
                                { parser->quasi_level++;
                                  (yyval.val) = rl(rlc(list(sys_unquote_s, (yyvsp[0].val), nao), (yyvsp[0].val)),
                                          num(parser->lineno)); }
#line 4699 "y.tab.c"
    break;

  case 264:
#line 1022 "parser.y"
                                { parser->quasi_level--; }
#line 4705 "y.tab.c"
    break;

  case 265:
#line 1023 "parser.y"
                                { parser->quasi_level++;
                                  (yyval.val) = rl(rlc(list(sys_splice_s, (yyvsp[0].val), nao), (yyvsp[0].val)),
                                          num(parser->lineno)); }
#line 4713 "y.tab.c"
    break;

  case 266:
#line 1026 "parser.y"
                                { parser_circ_def(parser, (yyvsp[0].val), unique_s); }
#line 4719 "y.tab.c"
    break;

  case 267:
#line 1027 "parser.y"
                                { parser_circ_def(parser, (yyvsp[-2].val), (yyvsp[0].val));
                                  (yyval.val) = (yyvsp[0].val); }
#line 4726 "y.tab.c"
    break;

  case 268:
#line 1029 "parser.y"
                                { (yyval.val) = parser_circ_ref(parser, (yyvsp[0].val)); }
#line 4732 "y.tab.c"
    break;

  case 269:
#line 1032 "parser.y"
                                { (yyval.val) = uref_helper(parser, (yyvsp[0].val)); }
#line 4738 "y.tab.c"
    break;

  case 270:
#line 1033 "parser.y"
                                { (yyval.val) = (yyvsp[0].val); }
#line 4744 "y.tab.c"
    break;

  case 271:
#line 1035 "parser.y"
                                { (yyval.val) = ifnign(symhlpr((yyvsp[0].lexeme), t)); }
#line 4750 "y.tab.c"
    break;

  case 272:
#line 1036 "parser.y"
                                { (yyval.val) = cons(var_s, cons((yyvsp[0].val), nil));
                                  rl((yyval.val), num(parser->lineno)); }
#line 4757 "y.tab.c"
    break;

  case 273:
#line 1038 "parser.y"
                                { (yyval.val) = (yyvsp[0].val); }
#line 4763 "y.tab.c"
    break;

  case 274:
#line 1039 "parser.y"
                                { (yyval.val) = (yyvsp[0].val); }
#line 4769 "y.tab.c"
    break;

  case 275:
#line 1040 "parser.y"
                                { (yyval.val) = (yyvsp[0].val); }
#line 4775 "y.tab.c"
    break;

  case 276:
#line 1041 "parser.y"
                                { (yyval.val) = (yyvsp[0].val); }
#line 4781 "y.tab.c"
    break;

  case 277:
#line 1042 "parser.y"
                                { (yyval.val) = (yyvsp[0].val); }
#line 4787 "y.tab.c"
    break;

  case 278:
#line 1043 "parser.y"
                                { (yyval.val) = (yyvsp[0].val); }
#line 4793 "y.tab.c"
    break;

  case 279:
#line 1044 "parser.y"
                                { (yyval.val) = (yyvsp[0].val); }
#line 4799 "y.tab.c"
    break;

  case 280:
#line 1045 "parser.y"
                                { (yyval.val) = (yyvsp[0].val); }
#line 4805 "y.tab.c"
    break;

  case 281:
#line 1046 "parser.y"
                                { (yyval.val) = (yyvsp[0].val); }
#line 4811 "y.tab.c"
    break;

  case 282:
#line 1047 "parser.y"
                                { (yyval.val) = (yyvsp[0].val); }
#line 4817 "y.tab.c"
    break;

  case 283:
#line 1048 "parser.y"
                                { (yyval.val) = (yyvsp[0].val); }
#line 4823 "y.tab.c"
    break;

  case 284:
#line 1049 "parser.y"
                                { (yyval.val) = (yyvsp[0].val); }
#line 4829 "y.tab.c"
    break;

  case 285:
#line 1050 "parser.y"
                                { (yyval.val) = rl((yyvsp[0].val), num((yyvsp[-1].lineno))); }
#line 4835 "y.tab.c"
    break;

  case 286:
#line 1051 "parser.y"
                                { (yyval.val) = rl(cons(quasilist_s, (yyvsp[0].val)), num((yyvsp[-1].lineno))); }
#line 4841 "y.tab.c"
    break;

  case 287:
#line 1052 "parser.y"
                                { (yyval.val) = (yyvsp[0].val); }
#line 4847 "y.tab.c"
    break;

  case 288:
#line 1053 "parser.y"
                                { (yyval.val) = rl(rlc(list(quote_s, (yyvsp[0].val), nao), (yyvsp[0].val)),
                                          num(parser->lineno)); }
#line 4854 "y.tab.c"
    break;

  case 289:
#line 1055 "parser.y"
                                { parser->quasi_level++; }
#line 4860 "y.tab.c"
    break;

  case 290:
#line 1056 "parser.y"
                                { parser->quasi_level--;
                                  (yyval.val) = rl(rlc(list(sys_qquote_s, (yyvsp[0].val), nao), (yyvsp[0].val)),
                                          num(parser->lineno)); }
#line 4868 "y.tab.c"
    break;

  case 291:
#line 1059 "parser.y"
                                { parser->quasi_level--; }
#line 4874 "y.tab.c"
    break;

  case 292:
#line 1060 "parser.y"
                                { parser->quasi_level++;
                                  (yyval.val) = rl(rlc(list(sys_unquote_s, (yyvsp[0].val), nao), (yyvsp[0].val)),
                                          num(parser->lineno)); }
#line 4882 "y.tab.c"
    break;

  case 293:
#line 1063 "parser.y"
                                { parser->quasi_level--; }
#line 4888 "y.tab.c"
    break;

  case 294:
#line 1064 "parser.y"
                                { parser->quasi_level++;
                                  (yyval.val) = rl(rlc(list(sys_splice_s, (yyvsp[0].val), nao), (yyvsp[0].val)),
                                          num(parser->lineno)); }
#line 4896 "y.tab.c"
    break;

  case 295:
#line 1067 "parser.y"
                                { uses_or2;
                                  (yyval.val) = rlc(list(rcons_s, (yyvsp[-2].val), (yyvsp[0].val), nao),
                                            or2((yyvsp[-2].val), (yyvsp[0].val))); }
#line 4904 "y.tab.c"
    break;

  case 296:
#line 1071 "parser.y"
                                { uses_or2;
                                  (yyval.val) = rlc(list(rcons_s, (yyvsp[-3].val),
                                                          uref_helper(parser, (yyvsp[0].val)),
                                                          nao),
                                            or2((yyvsp[-3].val), (yyvsp[0].val))); }
#line 4914 "y.tab.c"
    break;

  case 297:
#line 1077 "parser.y"
                                { uses_or2;
                                  (yyval.val) = rlc(list(rcons_s, (yyvsp[-2].val), (yyvsp[0].val), nao),
                                            or2((yyvsp[-2].val), (yyvsp[0].val))); }
#line 4922 "y.tab.c"
    break;

  case 298:
#line 1081 "parser.y"
                                { uses_or2;
                                  (yyval.val) = rlc(list(rcons_s, (yyvsp[-3].val),
                                                          uref_helper(parser, (yyvsp[0].val)),
                                                          nao),
                                            or2((yyvsp[-3].val), (yyvsp[0].val))); }
#line 4932 "y.tab.c"
    break;

  case 299:
#line 1086 "parser.y"
                                { (yyval.val) = qref_helper(parser, (yyvsp[-2].val), (yyvsp[0].val)); }
#line 4938 "y.tab.c"
    break;

  case 300:
#line 1087 "parser.y"
                                { (yyval.val) = qref_helper(parser,
                                                   cons(t, cons((yyvsp[-2].val), nil)),
                                                        (yyvsp[0].val)); }
#line 4946 "y.tab.c"
    break;

  case 301:
#line 1090 "parser.y"
                                { (yyval.val) = uref_helper(parser, (yyvsp[0].val)); }
#line 4952 "y.tab.c"
    break;

  case 302:
#line 1091 "parser.y"
                                { (yyval.val) = uoref_helper(parser, (yyvsp[0].val)); }
#line 4958 "y.tab.c"
    break;

  case 303:
#line 1092 "parser.y"
                                { parser_circ_def(parser, (yyvsp[0].val), unique_s); }
#line 4964 "y.tab.c"
    break;

  case 304:
#line 1093 "parser.y"
                                { parser_circ_def(parser, (yyvsp[-2].val), (yyvsp[0].val));
                                  (yyval.val) = (yyvsp[0].val); }
#line 4971 "y.tab.c"
    break;

  case 305:
#line 1095 "parser.y"
                                { (yyval.val) = parser_circ_ref(parser, (yyvsp[0].val)); }
#line 4977 "y.tab.c"
    break;

  case 306:
#line 1098 "parser.y"
                                { (yyval.val) = (yyvsp[0].val); }
#line 4983 "y.tab.c"
    break;

  case 307:
#line 1099 "parser.y"
                                { (yyval.val) = nil; }
#line 4989 "y.tab.c"
    break;

  case 308:
#line 1102 "parser.y"
                                { (yyval.val) = uref_helper(parser, (yyvsp[0].val)); }
#line 4995 "y.tab.c"
    break;

  case 309:
#line 1103 "parser.y"
                                { (yyval.val) = uoref_helper(parser, (yyvsp[0].val)); }
#line 5001 "y.tab.c"
    break;

  case 310:
#line 1104 "parser.y"
                                { (yyval.val) = (yyvsp[0].val); }
#line 5007 "y.tab.c"
    break;

  case 311:
#line 1107 "parser.y"
                                { (yyval.val) = regex_compile((yyvsp[-1].val), nil);
                                  end_of_regex(scnr);
                                  rl((yyval.val), num(parser->lineno)); }
#line 5015 "y.tab.c"
    break;

  case 312:
#line 1110 "parser.y"
                                { (yyval.val) = nil;
                                  yybadtok(yychar, lit("regex"));
                                  end_of_regex(scnr); }
#line 5023 "y.tab.c"
    break;

  case 313:
#line 1116 "parser.y"
                                { (yyval.val) = regex_compile((yyvsp[-1].val), nil);
                                  end_of_regex(scnr);
                                  rl((yyval.val), num(parser->lineno)); }
#line 5031 "y.tab.c"
    break;

  case 314:
#line 1120 "parser.y"
                                { (yyval.val) = nil;
                                  yybadtok(yychar, lit("regex"));
                                  end_of_regex(scnr); }
#line 5039 "y.tab.c"
    break;

  case 315:
#line 1125 "parser.y"
                                        { (yyval.val) = if3(cdr((yyvsp[0].val)),
                                                   cons(compound_s, (yyvsp[0].val)),
                                                   car((yyvsp[0].val))); }
#line 5047 "y.tab.c"
    break;

  case 316:
#line 1128 "parser.y"
                                        { (yyval.val) = list(or_s, (yyvsp[-2].val), (yyvsp[0].val), nao); }
#line 5053 "y.tab.c"
    break;

  case 317:
#line 1129 "parser.y"
                                        { (yyval.val) = list(and_s, (yyvsp[-2].val), (yyvsp[0].val), nao); }
#line 5059 "y.tab.c"
    break;

  case 318:
#line 1130 "parser.y"
                                        { (yyval.val) = list(compl_s, (yyvsp[0].val), nao); }
#line 5065 "y.tab.c"
    break;

  case 319:
#line 1131 "parser.y"
                                        { (yyval.val) = nil; }
#line 5071 "y.tab.c"
    break;

  case 320:
#line 1134 "parser.y"
                                { (yyval.val) = cons((yyvsp[0].val), nil); }
#line 5077 "y.tab.c"
    break;

  case 321:
#line 1135 "parser.y"
                                { (yyval.val) = cons((yyvsp[-1].val), (yyvsp[0].val)); }
#line 5083 "y.tab.c"
    break;

  case 322:
#line 1136 "parser.y"
                                { (yyval.val) = list((yyvsp[-2].val), list(compl_s, (yyvsp[0].val), nao), nao); }
#line 5089 "y.tab.c"
    break;

  case 323:
#line 1139 "parser.y"
                                { (yyval.val) = list(zeroplus_s, (yyvsp[-1].val), nao); }
#line 5095 "y.tab.c"
    break;

  case 324:
#line 1140 "parser.y"
                                { (yyval.val) = list(oneplus_s, (yyvsp[-1].val), nao); }
#line 5101 "y.tab.c"
    break;

  case 325:
#line 1141 "parser.y"
                                { (yyval.val) = list(optional_s, (yyvsp[-1].val), nao); }
#line 5107 "y.tab.c"
    break;

  case 326:
#line 1142 "parser.y"
                                { (yyval.val) = list(nongreedy_s, (yyvsp[-2].val), (yyvsp[0].val), nao); }
#line 5113 "y.tab.c"
    break;

  case 327:
#line 1143 "parser.y"
                                { if (first((yyvsp[-1].val)) == chr('^'))
                                  { if (rest((yyvsp[-1].val)))
                                      (yyval.val) = cons(cset_s, rest((yyvsp[-1].val)));
                                    else
                                      (yyval.val) = wild_s; }
                                  else
                                    (yyval.val) = cons(set_s, (yyvsp[-1].val)); }
#line 5125 "y.tab.c"
    break;

  case 328:
#line 1150 "parser.y"
                                { (yyval.val) = cons(set_s, nil); }
#line 5131 "y.tab.c"
    break;

  case 329:
#line 1151 "parser.y"
                                { (yyval.val) = nil;
                                  yybadtok(yychar, lit("regex character class")); }
#line 5138 "y.tab.c"
    break;

  case 330:
#line 1153 "parser.y"
                                { (yyval.val) = wild_s; }
#line 5144 "y.tab.c"
    break;

  case 331:
#line 1154 "parser.y"
                                { (yyval.val) = chr(']'); }
#line 5150 "y.tab.c"
    break;

  case 332:
#line 1155 "parser.y"
                                { (yyval.val) = chr('-'); }
#line 5156 "y.tab.c"
    break;

  case 333:
#line 1156 "parser.y"
                                { (yyval.val) = chr((yyvsp[0].chr)); }
#line 5162 "y.tab.c"
    break;

  case 334:
#line 1157 "parser.y"
                                { (yyval.val) = (yyvsp[0].val); }
#line 5168 "y.tab.c"
    break;

  case 335:
#line 1158 "parser.y"
                                { (yyval.val) = (yyvsp[-1].val); }
#line 5174 "y.tab.c"
    break;

  case 336:
#line 1159 "parser.y"
                                { (yyval.val) = nil;
                                  yybadtok(yychar, lit("regex subexpression")); }
#line 5181 "y.tab.c"
    break;

  case 337:
#line 1163 "parser.y"
                                        { (yyval.val) = cons((yyvsp[0].val), nil); }
#line 5187 "y.tab.c"
    break;

  case 338:
#line 1164 "parser.y"
                                        { (yyval.val) = cons((yyvsp[-1].val), (yyvsp[0].val)); }
#line 5193 "y.tab.c"
    break;

  case 339:
#line 1167 "parser.y"
                                { (yyval.val) = (yyvsp[0].val); }
#line 5199 "y.tab.c"
    break;

  case 340:
#line 1168 "parser.y"
                                { (yyval.val) = chr((yyvsp[0].chr)); }
#line 5205 "y.tab.c"
    break;

  case 341:
#line 1169 "parser.y"
                                { (yyval.val) = (yyvsp[0].val); }
#line 5211 "y.tab.c"
    break;

  case 342:
#line 1172 "parser.y"
                                { (yyval.val) = cons(chr((yyvsp[-2].chr)), chr((yyvsp[0].chr))); }
#line 5217 "y.tab.c"
    break;

  case 343:
#line 1174 "parser.y"
                                { (yyval.chr) = '?'; }
#line 5223 "y.tab.c"
    break;

  case 344:
#line 1175 "parser.y"
                                { (yyval.chr) = '.'; }
#line 5229 "y.tab.c"
    break;

  case 345:
#line 1176 "parser.y"
                                { (yyval.chr) = '*'; }
#line 5235 "y.tab.c"
    break;

  case 346:
#line 1177 "parser.y"
                                { (yyval.chr) = '+'; }
#line 5241 "y.tab.c"
    break;

  case 347:
#line 1178 "parser.y"
                                { (yyval.chr) = '('; }
#line 5247 "y.tab.c"
    break;

  case 348:
#line 1179 "parser.y"
                                { (yyval.chr) = ')'; }
#line 5253 "y.tab.c"
    break;

  case 349:
#line 1180 "parser.y"
                                { (yyval.chr) = '|'; }
#line 5259 "y.tab.c"
    break;

  case 350:
#line 1181 "parser.y"
                                { (yyval.chr) = '~'; }
#line 5265 "y.tab.c"
    break;

  case 351:
#line 1182 "parser.y"
                                { (yyval.chr) = '&'; }
#line 5271 "y.tab.c"
    break;

  case 352:
#line 1183 "parser.y"
                                { (yyval.chr) = '%'; }
#line 5277 "y.tab.c"
    break;

  case 353:
#line 1184 "parser.y"
                                { (yyval.chr) = '/'; }
#line 5283 "y.tab.c"
    break;

  case 354:
#line 1185 "parser.y"
                                { (yyval.chr) = (yyvsp[0].chr); }
#line 5289 "y.tab.c"
    break;

  case 355:
#line 1188 "parser.y"
                                { switch ((yyvsp[0].chr))
                                  { case 's':
                                      (yyval.val) = space_k; break;
                                    case 'S':
                                      (yyval.val) = cspace_k; break;
                                    case 'd':
                                      (yyval.val) = digit_k; break;
                                    case 'D':
                                      (yyval.val) = cdigit_k; break;
                                    case 'w':
                                      (yyval.val) = word_char_k; break;
                                    case 'W':
                                      (yyval.val) = cword_char_k; break; }}
#line 5307 "y.tab.c"
    break;

  case 357:
#line 1203 "parser.y"
                        { yyerr("newline expected after directive");
                          yyerrok; }
#line 5314 "y.tab.c"
    break;

  case 358:
#line 1207 "parser.y"
                                { (yyval.val) = null_string; }
#line 5320 "y.tab.c"
    break;

  case 359:
#line 1208 "parser.y"
                                { (yyval.val) = (yyvsp[-1].val);
                                  rl((yyval.val), num(parser->lineno)); }
#line 5327 "y.tab.c"
    break;

  case 360:
#line 1210 "parser.y"
                                { (yyval.val) = nil;
                                  yybadtok(yychar, lit("string literal")); }
#line 5334 "y.tab.c"
    break;

  case 361:
#line 1214 "parser.y"
                                { wchar_t ch;
                                  val str = string_own((yyvsp[0].lexeme));
                                  const wchar_t *cstr = c_str(str);

                                  if (cstr[1] == 0)
                                  { ch = cstr[0]; }
                                  else
                                  { ch = char_from_name(cstr);
                                    if (ch == L'!')
                                    { yyerrorf(scnr, lit("unknown character name: ~a"),
                                               str, nao); }}
                                  end_of_char(scnr);
                                  (yyval.val) = chr(ch); }
#line 5352 "y.tab.c"
    break;

  case 362:
#line 1227 "parser.y"
                                { (yyval.val) = chr((yyvsp[0].chr));
                                  end_of_char(scnr); }
#line 5359 "y.tab.c"
    break;

  case 363:
#line 1229 "parser.y"
                                { (yyval.val) = nil;
                                  yybadtok(yychar,
                                             lit("character literal")); }
#line 5367 "y.tab.c"
    break;

  case 364:
#line 1234 "parser.y"
                                { (yyval.val) = null_string; }
#line 5373 "y.tab.c"
    break;

  case 365:
#line 1235 "parser.y"
                                { (yyval.val) = cons(quasi_s, (yyvsp[-1].val));
                                  rlc((yyval.val), (yyvsp[-1].val));
                                  rl((yyval.val), num(parser->lineno)); }
#line 5381 "y.tab.c"
    break;

  case 366:
#line 1238 "parser.y"
                                { (yyval.val) = nil;
                                  yybadtok(yychar, lit("quasistring")); }
#line 5388 "y.tab.c"
    break;

  case 367:
#line 1242 "parser.y"
                                        { (yyval.val) = cons((yyvsp[0].val), nil);
                                          rl((yyval.val), num(parser->lineno)); }
#line 5395 "y.tab.c"
    break;

  case 368:
#line 1244 "parser.y"
                                        { (yyval.val) = cons((yyvsp[-1].val), (yyvsp[0].val));
                                          rl((yyval.val), num(parser->lineno)); }
#line 5402 "y.tab.c"
    break;

  case 369:
#line 1248 "parser.y"
                                { (yyval.val) = (yyvsp[0].val); }
#line 5408 "y.tab.c"
    break;

  case 370:
#line 1249 "parser.y"
                                { (yyval.val) = string_own((yyvsp[0].lexeme)); }
#line 5414 "y.tab.c"
    break;

  case 371:
#line 1250 "parser.y"
                                { (yyval.val) = (yyvsp[0].val); }
#line 5420 "y.tab.c"
    break;

  case 372:
#line 1251 "parser.y"
                                { (yyval.val) = cons(var_s, cons((yyvsp[0].val), nil));
                                  rl((yyval.val), num(parser->lineno)); }
#line 5427 "y.tab.c"
    break;

  case 373:
#line 1253 "parser.y"
                                { if (integerp((yyvsp[0].val)) || symbolp((yyvsp[0].val)))
                                    (yyval.val) = rlcp_tree(cons(var_s, cons((yyvsp[0].val), nil)),
                                                   (yyvsp[0].val));
                                  else
                                    (yyval.val) = (yyvsp[0].val); }
#line 5437 "y.tab.c"
    break;

  case 374:
#line 1260 "parser.y"
                                { (yyval.val) = mkstring(one, chr((yyvsp[0].chr))); }
#line 5443 "y.tab.c"
    break;

  case 375:
#line 1261 "parser.y"
                                { val ch = mkstring(one, chr((yyvsp[-1].chr)));
                                  (yyval.val) = string_extend(ch, (yyvsp[0].val)); }
#line 5450 "y.tab.c"
    break;

  case 376:
#line 1265 "parser.y"
                                        { (yyval.val) = mkstring(one, chr((yyvsp[0].chr))); }
#line 5456 "y.tab.c"
    break;

  case 377:
#line 1266 "parser.y"
                                        { (yyval.val) = string_extend((yyvsp[-1].val), chr((yyvsp[0].chr))); }
#line 5462 "y.tab.c"
    break;

  case 378:
#line 1269 "parser.y"
                                { (yyval.val) = nil; }
#line 5468 "y.tab.c"
    break;

  case 379:
#line 1270 "parser.y"
                                { (yyval.val) = (yyvsp[0].val); }
#line 5474 "y.tab.c"
    break;

  case 380:
#line 1271 "parser.y"
                                { val word = (yyvsp[-1].val);
                                  (yyval.val) = rlc(cons(word, (yyvsp[0].val)), (yyvsp[-1].val)); }
#line 5481 "y.tab.c"
    break;

  case 381:
#line 1273 "parser.y"
                                { (yyval.val) = nil;
                                  yybadtok(yychar, lit("word list")); }
#line 5488 "y.tab.c"
    break;

  case 382:
#line 1277 "parser.y"
                                 { (yyval.val) = nil; }
#line 5494 "y.tab.c"
    break;

  case 383:
#line 1278 "parser.y"
                                 { (yyval.val) = (yyvsp[0].val); }
#line 5500 "y.tab.c"
    break;

  case 384:
#line 1279 "parser.y"
                                 { val qword = cons(quasi_s, (yyvsp[-1].val));
                                   (yyval.val) = rlc(cons(qword, nil), (yyvsp[-1].val)); }
#line 5507 "y.tab.c"
    break;

  case 385:
#line 1283 "parser.y"
                                 { val qword = cons(quasi_s, (yyvsp[-2].val));
                                   (yyval.val) = rlc(cons(qword, (yyvsp[0].val)), (yyvsp[-2].val)); }
#line 5514 "y.tab.c"
    break;

  case 386:
#line 1287 "parser.y"
                                         { (yyval.val) = make_buf(zero, nil, nil);
                                           end_of_buflit(scnr); }
#line 5521 "y.tab.c"
    break;

  case 387:
#line 1289 "parser.y"
                                         { end_of_buflit(scnr);
                                           buf_trim((yyvsp[-1].val));
                                           (yyval.val) = (yyvsp[-1].val); }
#line 5529 "y.tab.c"
    break;

  case 388:
#line 1292 "parser.y"
                                         { yyerr("unterminated buffer literal");
                                           end_of_buflit(scnr);
                                           yyerrok; }
#line 5537 "y.tab.c"
    break;

  case 389:
#line 1297 "parser.y"
                                        { buf_put_u8((yyvsp[-1].val), length_buf((yyval.val)), (yyvsp[0].val));
                                          (yyval.val) = (yyvsp[-1].val); }
#line 5544 "y.tab.c"
    break;

  case 390:
#line 1299 "parser.y"
                                        { (yyval.val) = make_buf(zero, nil, num_fast(512));
                                          buf_put_u8((yyval.val), zero, (yyvsp[0].val)); }
#line 5551 "y.tab.c"
    break;

  case 391:
#line 1303 "parser.y"
                                        { (yyval.val) = num((yyvsp[-1].chr) << 4 | (yyvsp[0].chr)); }
#line 5557 "y.tab.c"
    break;

  case 392:
#line 1304 "parser.y"
                                        { (yyval.val) = zero;
                                          yyerr("unpaired digit in buffer literal");
                                          yyerrok; }
#line 5565 "y.tab.c"
    break;

  case 393:
#line 1311 "parser.y"
                                { (yyval.val) = mkexp(all_s, nil, num(parser->lineno)); }
#line 5571 "y.tab.c"
    break;

  case 394:
#line 1312 "parser.y"
                                { (yyval.val) = mkexp(some_s, nil, num(parser->lineno)); }
#line 5577 "y.tab.c"
    break;

  case 395:
#line 1313 "parser.y"
                                { (yyval.val) = mkexp(none_s, nil, num(parser->lineno)); }
#line 5583 "y.tab.c"
    break;

  case 396:
#line 1314 "parser.y"
                                { (yyval.val) = mkexp(maybe_s, nil, num(parser->lineno)); }
#line 5589 "y.tab.c"
    break;

  case 397:
#line 1315 "parser.y"
                                { (yyval.val) = mkexp(cases_s, nil, num(parser->lineno)); }
#line 5595 "y.tab.c"
    break;

  case 398:
#line 1316 "parser.y"
                                { (yyval.val) = mkexp(and_s, nil, num(parser->lineno)); }
#line 5601 "y.tab.c"
    break;

  case 399:
#line 1317 "parser.y"
                                { (yyval.val) = mkexp(or_s, nil, num(parser->lineno)); }
#line 5607 "y.tab.c"
    break;

  case 400:
#line 1318 "parser.y"
                                { (yyval.val) = mkexp(try_s, nil, num(parser->lineno)); }
#line 5613 "y.tab.c"
    break;

  case 401:
#line 1319 "parser.y"
                                { (yyval.val) = mkexp(finally_s, nil, num(parser->lineno)); }
#line 5619 "y.tab.c"
    break;

  case 402:
#line 1320 "parser.y"
                                { (yyval.val) = mkexp(else_s, nil, num(parser->lineno)); }
#line 5625 "y.tab.c"
    break;

  case 403:
#line 1321 "parser.y"
                                { (yyval.val) = mkexp(elif_s, nil, num(parser->lineno)); }
#line 5631 "y.tab.c"
    break;

  case 404:
#line 1323 "parser.y"
                                { (yyval.val) = mkexp(block_s, (yyvsp[-1].val), nil); }
#line 5637 "y.tab.c"
    break;

  case 405:
#line 1325 "parser.y"
                                { (yyval.val) = mkexp(choose_s, (yyvsp[-1].val), nil); }
#line 5643 "y.tab.c"
    break;

  case 406:
#line 1327 "parser.y"
                                { (yyval.val) = mkexp(collect_s, (yyvsp[-1].val), nil); }
#line 5649 "y.tab.c"
    break;

  case 407:
#line 1329 "parser.y"
                                { (yyval.val) = mkexp(coll_s, (yyvsp[-1].val), nil); }
#line 5655 "y.tab.c"
    break;

  case 408:
#line 1331 "parser.y"
                                { (yyval.val) = mkexp(gather_s, (yyvsp[-1].val), nil); }
#line 5661 "y.tab.c"
    break;

  case 409:
#line 1333 "parser.y"
                                { (yyval.val) = mkexp(define_s, (yyvsp[-1].val), nil); }
#line 5667 "y.tab.c"
    break;

  case 410:
#line 1335 "parser.y"
                                { (yyval.val) = mkexp(catch_s, (yyvsp[-1].val), nil); }
#line 5673 "y.tab.c"
    break;

  case 411:
#line 1337 "parser.y"
                                { (yyval.val) = mkexp(if_s, (yyvsp[-1].val), nil); }
#line 5679 "y.tab.c"
    break;

  case 412:
#line 1339 "parser.y"
                                { yyerr("@(output) doesn't nest"); }
#line 5685 "y.tab.c"
    break;


#line 5689 "y.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (scnr, parser, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *, YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (scnr, parser, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, scnr, parser);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, scnr, parser);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (scnr, parser, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif


/*-----------------------------------------------------.
| yyreturn -- parsing is finished, return the result.  |
`-----------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, scnr, parser);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, scnr, parser);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 1343 "parser.y"


const int have_yydebug = YYDEBUG;

int yylex(YYSTYPE *, yyscan_t scanner);

void yydebug_onoff(int val)
{
#if YYDEBUG
  yydebug = val;
#endif
}

static val sym_helper(parser_t *parser, wchar_t *lexeme, val meta_allowed)
{
  scanner_t *scnr = parser->scanner;
  int leading_at = *lexeme == L'@';
  wchar_t *tokfree = lexeme;
  wchar_t *colon = wcschr(lexeme, L':');
  val sym;

  if (leading_at) {
    if (!meta_allowed) {
      val tok = string_own(lexeme);
      yyerrorf(scnr, lit("~a: meta variable not allowed in this context"), tok, nao);
      return nil;
    }
    lexeme++;
  }

  if (colon != 0)
    *colon = 0;

  if (colon == lexeme) {
    val sym_name = string(colon + 1);
    scrub_scanner(parser->scanner, SYMTOK, tokfree);
    free(tokfree);
    sym = intern(sym_name, keyword_package);
  } else if (colon != 0) {
    val pkg_name = string(lexeme);
    val sym_name = string(colon + 1);
    scrub_scanner(parser->scanner, SYMTOK, tokfree);
    free(tokfree);
    if (equal(pkg_name, lit("#"))) {
      sym = make_sym(sym_name);
    } else {
      val package = find_package(pkg_name);
      if (!package) {
        yyerrorf(scnr, lit("~a:~a: package ~a not found"),
                 pkg_name, sym_name, pkg_name, nao);
        return nil;
      }
      sym = intern(sym_name, package);
    }
  } else {
    val sym_name = string(lexeme);
    scrub_scanner(parser->scanner, SYMTOK, tokfree);
    free(tokfree);
    sym = intern_fallback(sym_name, cur_package);
  }

  return leading_at ? rl(list(var_s, sym, nao), num(parser->lineno)) : sym;
}

static val expand_repeat_rep_args(val args)
{
  list_collect_decl (out, ptail);
  val exp_pair = nil, exp_pairs = nil;

  for (; args; args = cdr(args)) {
    val arg = car(args);

    if (consp(arg)) {
      if (exp_pairs) {
        list_collect_decl (iout, iptail);
        for (; arg; arg = cdr(arg)) {
          val iarg = car(arg);
          if (consp(iarg)) {
            val sym = first(iarg);
            iptail = list_collect(iptail, list(sym,
                                               expand(second(iarg), nil),
                                               nao));
            match_reg_var(sym);
          } else {
            iptail = list_collect(iptail, iarg);
            match_reg_var(iarg);
          }
        }
        ptail = list_collect(ptail, iout);
      } else if (exp_pair) {
        val sym = first(arg);
        ptail = list_collect(ptail, list(sym,
                                         expand(second(arg), nil),
                                         nao));
        match_reg_var(sym);
      } else {
        ptail = list_collect(ptail, arg);
      }
    } else if (!exp_pair && !exp_pairs) {
      if (arg == counter_k) {
        exp_pair = t;
        ptail = list_collect(ptail, arg);
        continue;
      } else if (arg == vars_k) {
        exp_pairs = t;
        ptail = list_collect(ptail, arg);
        continue;
      }
    } else if (exp_pair) {
      match_reg_var(arg);
    }

    exp_pair = exp_pairs = nil;
    ptail = list_collect(ptail, arg);
  }

  return out;
}

static val repeat_rep_helper(val sym, val args, val main, val parts)
{
  uses_or2;
  val exp_args = expand_repeat_rep_args(args);
  val single_parts = nil, single_parts_p = nil;
  val first_parts = nil, first_parts_p = nil;
  val last_parts = nil, last_parts_p = nil;
  val empty_parts = nil, empty_parts_p = nil;
  val mod_parts = nil, mod_parts_p = nil;
  val modlast_parts = nil, modlast_parts_p = nil;
  val iter;

  for (iter = parts; iter != nil; iter = cdr(iter)) {
    val part = car(iter);
    val sym = car(part);
    val clauses = copy_list(cdr(part));

    if (sym == single_s) {
      single_parts = nappend2(single_parts, clauses);
      single_parts_p = t;
    } else if (sym == first_s) {
      first_parts = nappend2(first_parts, clauses);
      first_parts_p = t;
    } else if (sym == last_s) {
      last_parts = nappend2(last_parts, clauses);
      last_parts_p = t;
    } else if (sym == empty_s) {
      empty_parts = nappend2(empty_parts, clauses);
      empty_parts_p = t;
    } else if (sym == mod_s) {
      mod_parts = cons(clauses, mod_parts);
      mod_parts_p = t;
    } else if (sym == modlast_s) {
      modlast_parts = cons(clauses, modlast_parts);
      modlast_parts_p = t;
    } else {
      abort();
    }
  }

  single_parts = or2(single_parts, single_parts_p);
  first_parts = or2(first_parts, first_parts_p);
  last_parts = or2(last_parts, last_parts_p);
  empty_parts = or2(empty_parts, empty_parts_p);
  mod_parts = or2(nreverse(mod_parts), mod_parts_p);
  modlast_parts = or2(nreverse(modlast_parts), modlast_parts_p);

  return list(sym, exp_args, main, single_parts, first_parts,
              last_parts, empty_parts, nreverse(mod_parts),
              nreverse(modlast_parts), nao);
}

static void process_catch_exprs(val exprs)
{
  val params = second(exprs);
  for (; params; params = cdr(params)) {
    val param = first(params);
    if (consp(param))
      match_reg_var(car(param));
    else
      match_reg_var(param);
  }
}

static val define_transform(parser_t *parser, val define_form)
{
  scanner_t *scnr = parser->scanner;
  val sym = first(define_form);
  val args = second(define_form);

  if (define_form == nil)
    return nil;

  assert (sym == define_s);

  if (args == nil) {
    yyerr("define requires arguments");
    return define_form;
  }

  if (!consp(args) || !listp(cdr(args))) {
    yyerr("bad define argument syntax");
    return define_form;
  } else {
    val name = first(args);
    val params = second(args);

    if (!symbolp(name)) {
      yyerr("function name must be a symbol");
      return define_form;
    }

    if (!proper_list_p(params)) {
      yyerr("invalid function parameter list");
      return define_form;
    }

    if (!all_satisfy(params, func_n1(symbolp), nil))
      yyerr("function parameters must be symbols");
  }

  return define_form;
}

static val optimize_text(val text_form)
{
  if (all_satisfy(rest(text_form), func_n1(stringp), nil))
    return cat_str(rest(text_form), lit(""));
  return text_form;
}

static val unquotes_occur(val quoted_form, int level)
{
  uses_or2;

  if (atom(quoted_form)) {
    return nil;
  } else {
    val sym = car(quoted_form);
    if (sym == sys_unquote_s || sym == sys_splice_s)
      return (level == 0) ? t : unquotes_occur(cdr(quoted_form), level - 1);
    if (sym == sys_qquote_s)
      return unquotes_occur(cdr(quoted_form), level + 1);
    return or2(unquotes_occur(sym, level),
               unquotes_occur(cdr(quoted_form), level));
  }
}

val expand_meta(val form, val menv)
{
  val sym;

  if (atom(form))
    return form;

  menv = default_arg(menv, make_env(nil, nil, nil));

  if ((sym = car(form)) == quasi_s) {
    if (opt_compat && opt_compat <= 128) {
      list_collect_decl (out, ptail);

      for (; consp(form); form = cdr(form)) {
        val subform = car(form);
        if (consp(subform) && car(subform) == expr_s)
          ptail = list_collect(ptail, expand_meta(subform, menv));
        else
          ptail = list_collect(ptail, subform);
      }

      ptail = list_collect_nconc(ptail, form);

      return rlcp(out, form);
    }

    return expand(form, nil);
  }

  if ((sym = car(form)) == expr_s) {
    val exp_x = expand(second(form), menv);
    if (!bindable(exp_x))
      return rlcp(cons(sym, cons(exp_x, nil)), form);
    return rlcp(cons(var_s, cons(exp_x, nil)), form);
  }

  if (sym == var_s) {
    val var_x = expand(second(form), menv);
    if (!bindable(var_x))
      return rlcp(cons(expr_s, cons(var_x, nil)), form);
    return rlcp(cons(var_s, cons(var_x, nil)), form);
  }

  {
    list_collect_decl (out, ptail);

    for (; consp(form); form = cdr(form)) {
      loc nptail = list_collect(ptail, expand_meta(car(form), menv));
      rlcp(deref(ptail), form);
      ptail = nptail;
    }

    ptail = list_collect_nconc(ptail, form);

    return out;
  }
}

static val rlviable(val form)
{
  switch (type(form)) {
  case NIL:
  case LIT:
  case CHR:
  case NUM:
  case SYM:
  case BGNUM:
  case FLNUM:
    return nil;
  default:
    return t;
  }
}

val rlset(val form, val info)
{
  if (rlviable(form)) {
    loc place = gethash_l(lit("rlcp"), form_to_ln_hash, form, nulloc);
    if (nilp(deref(place)))
      set(place, info);
  }
  return form;
}

val rlrec(parser_t *parser, val form, val line)
{
  if (parser->rec_source_loc)
    rlset(form, cons(line, parser->name));
  return form;
}

val rlcp_parser(parser_t *parser, val to, val from)
{
  if (parser->rec_source_loc)
    rlset(to, source_loc(from));
  return to;
}

static val rlcp_tree_rec(val to, val from, struct circ_stack *up)
{
  val ret = to;

  while (consp(to)) {
    val a = car(to);
    struct circ_stack rlcs = { up, a };
    rlcp(to, from);
    if (!parser_callgraph_circ_check(up, a))
      break;
    rlcp_tree_rec(a, from, &rlcs);
    to = cdr(to);
    if (!parser_callgraph_circ_check(up, to))
      break;
  }
  return ret;
}


val rlcp_tree(val to, val from)
{
  return rlcp_tree_rec(to, from, 0);
}

static wchar_t char_from_name(const wchar_t *name)
{
  static struct {
    const wchar_t *name;
    const wchar_t ch;
  } map[] = {
    { L"nul", 0 },
    { L"alarm", L'\a' },
    { L"backspace", L'\b' },
    { L"tab", L'\t' },
    { L"linefeed", L'\n' },
    { L"newline", L'\n' },
    { L"vtab", L'\v' },
    { L"page", L'\f' },
    { L"return", L'\r' },
    { L"esc", 27 },
    { L"space", L' ' },
    { L"pnul", 0xDC00 },
    { 0, 0 },
  };
  int i;

  for (i = 0; map[i].name; i++) {
    if (wcscmp(map[i].name, name) == 0)
      return map[i].ch;
  }

  return L'!'; /* code meaning not found */
}

static val make_expr(parser_t *parser, val sym, val rest, val lineno)
{
  val expr = cons(sym, rest);
  val ret = cons(expr_s, cons(expand(expr, nil), nil));

  if (rest) {
    rlc(expr, rest);
    rlc(ret, rest);
  } else {
    rl(expr, lineno);
    rl(ret, lineno);
  }

  return ret;
}

static val check_parse_time_action(val spec_rev)
{
  val line = first(spec_rev);

  if (consp(line)) {
    val elem = first(line);
    if (consp(elem)) {
      val sym = car(elem);
      if (sym == include_s) {
        return nappend2(nreverse(include(line)), rest(spec_rev));
      }
      if (sym == mdo_s) {
        eval_intrinsic(cons(progn_s, cdr(elem)), nil);
        return nil;
      }
      if (sym == in_package_s) {
        eval_intrinsic(elem, nil);
        return nil;
      }
    }
  }
  return spec_rev;
}

static void misplaced_consing_dot_check(scanner_t *scanner, val term_atom_cons)
{
  if (car(term_atom_cons) != unique_s) {
    yyerrorf(scanner, lit("misplaced consing dot"), nao);
    rplaca(term_atom_cons, unique_s);
  }
}

static val uref_helper(parser_t *parser, val expr)
{
  if (consp(expr) && car(expr) == qref_s) {
    return rplaca(expr, uref_s);
  } else {
    return rl(rlc(list(uref_s, expr, nao), expr), num(parser->lineno));
  }
}

static val uoref_helper(parser_t *parser, val expr)
{
  val uref = uref_helper(parser, expr);
  rplacd(uref, cons(t, cdr(uref)));
  return uref;
}

static val qref_helper(parser_t *parser, val lexpr, val rexpr)
{
  uses_or2;

  if (consp(rexpr) && car(rexpr) == qref_s) {
    rplacd(rexpr, rlc(cons(lexpr, cdr(rexpr)), lexpr));
    return rl(rexpr, num(parser->lineno));
  } else {
    return rl(rlc(list(qref_s, lexpr, rexpr, nao),
                  or2(lexpr, rexpr)),
                  num(parser->lineno));
  }
}

static val fname_helper(parser_t *parser, val name)
{
  if (!name) {
    return nil;
  } else if (!bindable(name)) {
    yyerrorf(parser->scanner, lit("#T: ~s isn't a function name"),
             name, nao);
  } else if (!memq(name, tree_fun_whitelist)) {
    yyerrorf(parser->scanner, lit("#T: ~s not in *tree-fun-whitelist*"),
             name, nao);
  } else {
    val fbinding = lookup_fun(nil, name);
    if (fbinding)
      return cdr(fbinding);
    yyerrorf(parser->scanner, lit("#T: function named ~s doesn't exist"),
             name, nao);
  }

  return nil;
}

#ifndef YYEOF
#define YYEOF 0
#endif

void yybadtoken(parser_t *parser, int tok, val context)
{
  val problem = nil;
  scanner_t *scnr = parser->scanner;

  switch (tok) {
  case ERRTOK:
    return;
  case SPACE:   problem = lit("space"); break;
  case TEXT:    problem = lit("text"); break;
  case SYMTOK:  problem = lit("symbol-token"); break;
  case METANUM: problem = lit("metanum"); break;
  case ALL:     problem = lit("\"all\""); break;
  case SOME:    problem = lit("\"some\""); break;
  case NONE:    problem = lit("\"none\""); break;
  case MAYBE:   problem = lit("\"maybe\""); break;
  case CASES:   problem = lit("\"cases\""); break;
  case CHOOSE:  problem = lit("\"choose\""); break;
  case AND:     problem = lit("\"and\""); break;
  case OR:      problem = lit("\"or\""); break;
  case END:     problem = lit("\"end\""); break;
  case COLLECT: problem = lit("\"collect\""); break;
  case UNTIL:   problem = lit("\"until\""); break;
  case COLL:    problem = lit("\"coll\""); break;
  case OUTPUT:  problem = lit("\"output\""); break;
  case REPEAT:  problem = lit("\"repeat\""); break;
  case REP:     problem = lit("\"rep\""); break;
  case SINGLE:  problem = lit("\"single\""); break;
  case FIRST:   problem = lit("\"first\""); break;
  case LAST:    problem = lit("\"last\""); break;
  case EMPTY:   problem = lit("\"empty\""); break;
  case DEFINE:  problem = lit("\"define\""); break;
  case TRY:     problem = lit("\"try\""); break;
  case CATCH:   problem = lit("\"catch\""); break;
  case FINALLY: problem = lit("\"finally\""); break;
  case IF:      problem = lit("\"if\""); break;
  case ELIF:    problem = lit("\"elif\""); break;
  case ELSE:    problem = lit("\"else\""); break;
  case NUMBER:  problem = lit("number"); break;
  case REGCHAR: problem = lit("regular expression character"); break;
  case REGTOKEN: problem = lit("regular expression token"); break;
  case LITCHAR: problem = lit("string literal character"); break;
  case CONSDOT:
  case LAMBDOT: problem = lit("consing dot"); break;
  case DOTDOT: problem = lit(".."); break;
  case OLD_DOTDOT:     problem = lit(".."); break;
  case UREFDOT:        problem = lit("referencing dot"); break;
  case OREFDOT:
  case UOREFDOT:       problem = lit("referencing .?"); break;
  case HASH_BACKSLASH: problem = lit("#\\"); break;
  case HASH_SLASH:     problem = lit("#/"); break;
  case HASH_H:         problem = lit("#H"); break;
  case HASH_S:         problem = lit("#S"); break;
  case HASH_R:         problem = lit("#R"); break;
  case HASH_N:         problem = lit("#N"); break;
  case HASH_T:         problem = lit("#T"); break;
  case HASH_SEMI:      problem = lit("#;"); break;
  case HASH_N_EQUALS:  problem = lit("#<n>="); break;
  case HASH_N_HASH:    problem = lit("#<n>#"); break;
  case HASH_B_QUOTE:   problem = lit("#b'"); break;
  case WORDS:   problem = lit("#\""); break;
  case WSPLICE: problem = lit("#*\""); break;
  case QWORDS:         problem = lit("#`"); break;
  case QWSPLICE:       problem = lit("#*`"); break;
  }

  if (problem != 0)
    if (context)
      yyerrorf(scnr, lit("misplaced ~a in ~a"), problem, context, nao);
    else
      yyerrorf(scnr, lit("unexpected ~a"), problem, nao);
  else
    if (context) /* Byacc sets yychar to 0 */
      if (tok == YYEOF || tok == YYEMPTY)
        yyerrorf(scnr, lit("unterminated ~a"), context, nao);
      else if (tok == '\n')
        yyerrorf(scnr, lit("newline in ~a"), context, nao);
      else
        yyerrorf(scnr, lit("misplaced character ~a in ~a"), chr(tok), context, nao);
    else
      if (tok == YYEOF)
        yyerrorf(scnr, lit("unexpected end of input"), nao);
      else if (tok == YYEMPTY)
        return;
      else
        yyerrorf(scnr, lit("unexpected character ~a"), chr(tok), nao);
}

int parse_once(val self, val stream, val name)
{
  int res = 0;
#if CONFIG_DEBUG_SUPPORT
  unsigned dbg_state = debug_clear(opt_dbg_expansion ? 0 : DBG_ENABLE);
#endif
  val parser_obj = ensure_parser(stream, name);
  parser_t *parser = parser_get_impl(self, parser_obj);
  parser->rec_source_loc = 1;

  uw_catch_begin(cons(error_s, nil), esym, eobj);


  res = yyparse(parser->scanner, parser);

  parser_resolve_circ(parser);

  uw_catch(esym, eobj) {
    yyerrorf(parser->scanner, lit("error exception during parse"), nao);
    uw_throw(esym, eobj);
  }

  uw_unwind {
#if CONFIG_DEBUG_SUPPORT
    debug_set(dbg_state);
#endif
  }

  uw_catch_end;

  return res;
}

int parse(parser_t *parser, val name, enum prime_parser prim)
{
  int res = 0;
  cnum start_line = parser->lineno;

  parser->errors = 0;
  parser->eof = 0;
  parser->ignore = 0;
  parser->prepared_msg = nil;
  parser->circ_ref_hash = nil;
  parser->circ_count = 0;
  parser->syntax_tree = nil;
  parser->quasi_level = 0;

  prime_parser(parser, name, prim);

  uw_catch_begin(cons(error_s, nil), esym, eobj);

  res = yyparse(parser->scanner, parser);

  prime_parser_post(parser, prim);

  parser_resolve_circ(parser);

  uw_catch(esym, eobj) {
    yyerrorf(parser->scanner, lit("error exception during parse"), nao);
    uw_throw(esym, eobj);
  }

  uw_unwind;

  uw_catch_end;

  if (parser->errors && parser->syntax_tree == nil &&
      parser->lineno != start_line)
  {
    yyerrorf(parser->scanner, lit("while parsing form starting at line ~a"),
             num(start_line), nao);
  }

  return res;
}
